/*###############################################################################
## OpenBTrainer project
##
## Copyright (C) 2009 Jose Luis Falcón Ramírez  jose.falconra@alum.uca.es
##
## This program is free software; you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published by
## the Free Software Foundation; either version 3 of the License, or
## (at your option) any later version.
##
## This program is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.
##
## You should have received a copy of the GNU General Public License
## along with this program; if not, write to the Free Software
## Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
###############################################################################*/


#ifndef _JUEGO_H
#define	_JUEGO_H
#include "perfiles.h"
#include "musica.h"
/**Clase juego:
 * En esta clase servirá para llamar a los distintos juegos y cargar los menus de las categorías
 */
class juego {
public:
    /**Constructor de la clase juego**/
    juego();
    juego(const juego& orig);
    /**Llama al menu de minijuegos y carga el juego que se le indica con el ratón
     * @param *perfil tenemos que pasar un puntero al objeto perfil para actualizar las puntuaciones
     * @param pantalla debemos pasar como parametro la superficie de la pantalla inicializada*/
    void minijuegos(perfiles *perfil, Musica m,SDL_Surface* pantalla);
    /**Llama al menu de categorías y carga el juego que se le indica con el ratón
     * @param *perfil tenemos que pasar un puntero al objeto perfil para actualizar las puntuaciones
     * @param pantalla debemos pasar como parametro la superficie de la pantalla inicializada*/
    void Categorias(perfiles *perfil, Musica m,SDL_Surface* pantalla);
    /**Llama al modo de juego Arcade, el cual llama a su vez a cuatro juegos distintos
     * @param *perfil tenemos que pasar un puntero al objeto perfil para actualizar las puntuaciones
     * @param pantalla debemos pasar como parametro la superficie de la pantalla inicializada*/
    void Arcade(perfiles *perfil, Musica m,SDL_Surface *pantalla);
    /**Inicializa la pantalla y llama a los distintos Subsistemas que necesitamos*/
    SDL_Surface* iniciar_pantalla();
private:
    void DibujarEscenarioCategorias(SDL_Surface* pantalla);
    void DesplegarBotones(Uint32 categoria, SDL_Surface* pantalla);
};
#endif	/*_JUEGO_H*/
