/*###############################################################################
## OpenBTrainer project
##
## Copyright (C) 2009 Jose Luis Falcón Ramírez  jose.falconra@alum.uca.es
##
## This program is free software; you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published by
## the Free Software Foundation; either version 3 of the License, or
## (at your option) any later version.
##
## This program is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.
##
## You should have received a copy of the GNU General Public License
## along with this program; if not, write to the Free Software
## Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
###############################################################################*/

#ifndef _LOGICA_H
#define	_LOGICA_H

class logica {
public:
    logica();
    /** Función que lanza el juego Luces y Sombras
     * @param nivelinicial: Nos sirve para que el juego inicie en un determinado nivel, usado en modo arcade.
     * @param arcade: Indica al juego que estamos en modo arcade y que no debe aumentar el nivel.
     * @param pantalla: Le pasamos la variable pantalla para que se imprima el juego en ella.
     */
    Uint32 lucesysombras(Uint32 nivelinicial, bool arcade, SDL_Surface* pantalla);
    virtual ~logica();
private:
    void dibujarescenariolys(SDL_Surface* pantalla);
    SDL_Surface* cargartablero(Uint32 nivel,bool tablero[][5]);
    void movimientolys(Uint32 x, Uint32 y, bool tablero[][5]);
    void dibujarmatrizlys(bool tablero[][5], SDL_Surface* pantallatablero);
    bool terminadolys(bool tablero[][5]);
};

#endif	/* _LOGICA_H */

