/*###############################################################################
## OpenBTrainer project
##
## Copyright (C) 2009 Jose Luis Falcón Ramírez  jose.falconra@alum.uca.es
##
## This program is free software; you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published by
## the Free Software Foundation; either version 3 of the License, or
## (at your option) any later version.
##
## This program is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.
##
## You should have received a copy of the GNU General Public License
## along with this program; if not, write to the Free Software
## Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
###############################################################################*/

#include <cstdlib>
#include <iostream>
#include <SDL/SDL.h>
#include <SDL/SDL_image.h>
#include <SDL/SDL_ttf.h>
#include <SDL/SDL_mixer.h>
#include <sys/stat.h>
#include "juego.h"
#include "perfiles.h"
#include "minijuego.h"
#include "musica.h"


using namespace std;

int main ( int argc, char** argv )
{
	//Cargamos el Juego
	juego game;
        SDL_Surface* pantalla=game.iniciar_pantalla();
        SDL_WM_SetCaption( "OpenBTrainer", "OpenBTrainer" );
    // Asegurarse de al salir liberar SDL
        atexit(SDL_Quit);
        char cadena[80], nombperfil[21];
        int w,h;
        Musica m("../musica/menu.ogg");
        m.Reproducir();
        perfiles perfil;
        perfil.cargar(pantalla);
    // Cargar una imagen
    carga: SDL_Surface* bmp = IMG_Load("../imagenes/fondos/portada.png");
    if (!bmp)
    {
        cerr<<"Imposible cargar bitmap: "<< SDL_GetError()<<endl;
        return 1;
    }

    // centrar la imagen en la pantalla
    SDL_Rect dstrect;
    dstrect.x = (pantalla->w - bmp->w) / 2;
    dstrect.y = (pantalla->h - bmp->h) / 2;
    SDL_BlitSurface(bmp, 0, pantalla, &dstrect);
    //Cargar botones
    SDL_Surface* boton1 = IMG_Load("../imagenes/botones/Arcade.png");
    if(!boton1)
    {
        cerr<<"Imposible cargar bitmap: "<< SDL_GetError()<<endl;
        return 1;
    }
    SDL_Rect rectbtn;
    rectbtn.x=500;
    rectbtn.y=120;
    SDL_BlitSurface(boton1, 0, pantalla, &rectbtn);
    SDL_Surface* boton2 = IMG_Load("../imagenes/botones/Categorias.png");
    if(!boton2)
    {
        cerr<<"Imposible cargar bitmap: "<< SDL_GetError()<<endl;
        return 1;
    }
    rectbtn.y=180;
    SDL_BlitSurface(boton2, 0, pantalla, &rectbtn);
    SDL_Surface* boton3 = IMG_Load("../imagenes/botones/Minijuegos.png");
    if(!boton3)
    {
        cerr<<"Imposible cargar bitmap: "<< SDL_GetError()<<endl;
        return 1;
    }
    rectbtn.y=240;
    SDL_BlitSurface(boton3, 0, pantalla, &rectbtn);
    SDL_Surface* boton4 = IMG_Load("../imagenes/botones/Borrar_Perfil.png");
    if(!boton4)
    {
        cerr<<"Imposible cargar bitmap: "<< SDL_GetError()<<endl;
        return 1;
    }
    rectbtn.y=320;
    SDL_BlitSurface(boton4, 0, pantalla, &rectbtn);
    SDL_Surface* boton5 = IMG_Load("../imagenes/botones/Cambiar_Perfil.png");
    if(!boton5)
    {
        cerr<<"Imposible cargar bitmap: "<< SDL_GetError()<<endl;
        return 1;
    }
    rectbtn.y=380;
    SDL_BlitSurface(boton5, 0, pantalla, &rectbtn);
    //Mensaje de Perfil Activado
    //Cargamos los tipos de letras
    TTF_Font *fuente;
    fuente = TTF_OpenFont("../fuentes/FreeSansBold.ttf", 20);
    if(!fuente)
    {
        cerr<<"Error no se encuentra la fuente: "<<SDL_GetError()<<endl;
        exit(1);
    }
    //Cargamos el numero a recordar
    SDL_Surface *texto;
    SDL_Color color;
    // Establecemos el color para la fuente
    color.r = 255;
    color.g = 255;
    color.b = 255;
    perfil.nombreperfilactual(nombperfil);
    sprintf(cadena,"Hola %s, me alegro de verte",nombperfil);
    TTF_SizeUTF8(fuente, cadena, &w, &h);
    texto = TTF_RenderText_Blended(fuente, cadena, color);
    SDL_Rect dest;
    dest.x=50;
    dest.y=550;
    SDL_BlitSurface(texto, 0, pantalla, &dest);
    // bucle opciones
    bool done = false;
    while (!done)
    {
        // Manejo de eventos
        SDL_Event event;
        while(SDL_PollEvent(&event)){
        	//tecl.actualizar();
       		if(event.type==SDL_QUIT){
        		done=true;
        		break;
       		 }
                if(event.type==SDL_MOUSEBUTTONDOWN)
                {
                    Uint32 mousex, mousey;
                    mousex=event.button.x;
                    mousey=event.button.y;
                    //Comprobacion btn modo arcade
                    if(mousex>500&&mousey>120&&mousex<(500+150)&&mousey<(120+40)){
                        cout<<"Pulsacion de boton: Modo Arcade"<<endl;
                        game.Arcade(&perfil,m,pantalla);
                        /*Musica m("../musica/menu.ogg");
                        m.Reproducir();*/
                        goto carga;
                    }
                    //Comprobacion btn Categorias
                    if(mousex>500&&mousey>180&&mousex<(500+150)&&mousey<(180+40)){
                        cout<<"Pulsacion de boton: Categorias"<<endl;
                        game.Categorias(&perfil, m,pantalla);
                        /*Musica m("../musica/menu.ogg");
                        m.Reproducir();*/
                        goto carga;
                    }

                    //Comprobacion btn Minijuegos
                    if(mousex>500&&mousey>240&&mousex<(500+150)&&mousey<(240+40)){
                        cout<<"Pulsacion de boton: Minijuegos"<<endl;
                        game.minijuegos(&perfil, m,pantalla);
                        /*Musica m("../musica/menu.ogg");
                        m.Reproducir();*/
                        goto carga;
                    }
                    if(mousex>500&&mousey>320&&mousex<(500+150)&&mousey<(320+40)){
                        cout<<"Pulsacion de boton: Borrar Perfil"<<endl;
                        perfil.borrarperfil();
                        perfil.cargar(pantalla);
                        goto carga;
                    }
                    if(mousex>500&&mousey>380&&mousex<(500+150)&&mousey<(380+40)){
                        cout<<"Pulsacion de boton: Cambiar Perfil"<<endl;
                        perfil.cargar(pantalla);
                        goto carga;
                    }
                }
        }
        SDL_Flip(pantalla);
    } // end main loop
    m.Pausar();
    // all is well ;)
    printf("Exited cleanly\n");
    return 0;
}
