/*###############################################################################
## OpenBTrainer project
##
## Copyright (C) 2009 Jose Luis Falcón Ramírez  jose.falconra@alum.uca.es
##
## This program is free software; you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published by
## the Free Software Foundation; either version 3 of the License, or
## (at your option) any later version.
##
## This program is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.
##
## You should have received a copy of the GNU General Public License
## along with this program; if not, write to the Free Software
## Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
###############################################################################*/

#include <SDL/SDL.h>
#include <SDL/SDL_image.h>
#include <SDL/SDL_ttf.h>
#include <vector>
#include <stdlib.h>
#include <iostream>
#include "minijuego.h"
#include "reloj.h"

using namespace std;
minijuego::minijuego(){
    srand(time(0));
}

void minijuego::voltear_carta(SDL_Surface* pantalla, SDL_Rect rectcarta, datosmemorion datos, Uint32 x, Uint32 y){
    char ruta[50];
    sprintf(ruta,"../imagenes/cartas/%d.png",datos.matriz[x][y]);
    SDL_Surface* carta = IMG_Load(ruta);
    SDL_BlitSurface(carta, 0, pantalla, &rectcarta);
}

Uint32 minijuego::comprobacion_parejas(SDL_Surface* pantalla, datosmemorion *datos, tipolevantada carta_levantada, Uint32 x, Uint32 y, Uint32 *cartasEmparejadas){
    if((carta_levantada.x!=x&&carta_levantada.y==y)||(carta_levantada.x==x&&carta_levantada.y!=y)||(carta_levantada.x!=x&&carta_levantada.y!=y)){
            if(datos->matriz[x][y]==datos->matriz[carta_levantada.x][carta_levantada.y]){
                datos->matriz[x][y]=0;
                datos->matriz[carta_levantada.x][carta_levantada.y]=0;
                SDL_Flip(pantalla);
                SDL_Delay(500);
                dibujar_mesa(pantalla, *datos);
                *cartasEmparejadas+=2;
            }
            else{
                SDL_Flip(pantalla);
                SDL_Delay(500);
                dibujar_mesa(pantalla, *datos);
            }
            return 0;
        }
    else
        return 1;
}

void minijuego::dibujar_mesa(SDL_Surface* pantalla, datosmemorion datos){
    SDL_FillRect(pantalla,NULL,SDL_MapRGB(pantalla->format,0,0,0));
    SDL_Surface* fondo = IMG_Load("../imagenes/fondos/mesa_cartas.png");
     if(!fondo)
    {
        cerr<<"Imposible cargar png: "<< SDL_GetError()<<endl;
        exit(1);
    }
     SDL_BlitSurface(fondo, 0, pantalla, 0);
     SDL_Surface* boton1 = IMG_Load("../imagenes/botones/Salir.png");
    if(!boton1)
    {
        cerr<<"Imposible cargar imagen: "<< SDL_GetError()<<endl;
        exit(1);
    }
    SDL_Rect rectbtn;
    rectbtn.x=630;
    rectbtn.y=20;
    SDL_BlitSurface(boton1, 0, pantalla, &rectbtn);
    SDL_Rect rectcarta;
    SDL_Surface* carta = IMG_Load("../imagenes/cartas/tux.png");
    switch(datos.numCartas){
        case 12:{
            rectcarta.x=250;
            rectcarta.y=150;
            for(int i=0;i<3;i++){
                for(int j=0;j<4;j++){
                    if(datos.matriz[j][i]!=0)
                        SDL_BlitSurface(carta, 0, pantalla, &rectcarta);
                    rectcarta.x+=96;
                }
                rectcarta.x=250;
                rectcarta.y+=152;
            }
        }
        break;
        case 18:{
            rectcarta.x=125;
            rectcarta.y=150;
            SDL_Surface* carta = IMG_Load("../imagenes/cartas/tux.png");
            for(int i=0;i<3;i++){
                for(int j=0;j<6;j++){
                    if(datos.matriz[j][i]!=0)
                        SDL_BlitSurface(carta, 0, pantalla, &rectcarta);
                    rectcarta.x+=96;
                }
                rectcarta.x=125;
                rectcarta.y+=152;
            }
        }
        break;
        case 24:{
            rectcarta.x=25;
            rectcarta.y=150;
            SDL_Surface* carta = IMG_Load("../imagenes/cartas/tux.png");
            for(int i=0;i<3;i++){
                for(int j=0;j<8;j++){
                    if(datos.matriz[j][i]!=0)
                        SDL_BlitSurface(carta, 0, pantalla, &rectcarta);
                    rectcarta.x+=96;
                }
                rectcarta.x=25;
                rectcarta.y+=152;
            }
        }
    }
}

Uint32 minijuego::memorion(SDL_Surface *pantalla){
    bool terminar=false;
    Uint32 nivel=1;
    reloj crono(720, 560);
    carga: Uint32 posduplx,posduply,cont=0, contCartas=0, estado=0, tiempo=0, cartasEmparejadas=0;
    Uint32 numero, min, seg;
    SDL_Rect recttiempo;
    recttiempo.x=700;
    recttiempo.y=550;
    recttiempo.h=50;
    recttiempo.w=100;
    
    vector<Uint32> ocurrencias;
    datosmemorion datos;
    tipolevantada carta_levantada;
    SDL_Surface* fondo = IMG_Load("../imagenes/fondos/mesa_cartas.png");
     if(!fondo)
    {
        cerr<<"Imposible cargar imagen: "<< SDL_GetError()<<endl;
        return 1;
    }
     SDL_BlitSurface(fondo, 0, pantalla, 0);
     SDL_Surface* boton1 = IMG_Load("../imagenes/botones/Salir.png");
    if(!boton1)
    {
        cerr<<"Imposible cargar imagen: "<< SDL_GetError()<<endl;
        return 1;
    }
    SDL_Rect rectbtn;
    rectbtn.x=630;
    rectbtn.y=20;
    SDL_BlitSurface(boton1, 0, pantalla, &rectbtn);
    //bucle de dibujado de cartas segun niveles
    SDL_Rect rectcarta;
    switch(nivel){
        case 1:{
            
            rectcarta.x=250;
            rectcarta.y=150;
            SDL_Surface* carta = IMG_Load("../imagenes/cartas/tux.png");
            datos.numCartas=12;
            cont=0;
            //Inicializacion de matriz a 0
            for(int i=0;i<3;i++)
                for(int j=0;j<4;j++)
                    datos.matriz[j][i]=0;
            for(int i=0;i<3;i++){
                for(int j=0;j<4;j++){
                    SDL_BlitSurface(carta, 0, pantalla, &rectcarta);
                    rectcarta.x+=96;
                    if(contCartas<datos.numCartas){
                        cout<<"ContCartas: "<<contCartas<<endl;
                        if(datos.matriz[j][i]==0){
                            contCartas+=2;
                            numero=1+rand()%15;
                            datos.matriz[j][i]=numero;
                            for(Uint32 c=0;c<ocurrencias.size();c++){
                                if(numero==ocurrencias[c]){
                                    c=0;
                                    numero=1+rand()%15;
                                }
                            }
                            datos.matriz[j][i]=numero;
                            ocurrencias.push_back(numero);

                            posduplx=rand()%4;
                            posduply=rand()%3;

                            while(datos.matriz[posduplx][posduply]!=0){
                                 posduplx=rand()%4;
                                 posduply=rand()%3;
                            }
                            datos.matriz[posduplx][posduply]=numero;
                        }
                    }
                }
                rectcarta.x=250;
                rectcarta.y+=152;
            }
            break;
        }
        case 2:{
            rectcarta.x=125;
            rectcarta.y=150;
            SDL_Surface* carta = IMG_Load("../imagenes/cartas/tux.png");
            datos.numCartas=18;
            cont=0;
            //Inicializacion de matriz a 0
            for(int i=0;i<3;i++)
                for(int j=0;j<6;j++)
                    datos.matriz[j][i]=0;
            for(int i=0;i<3;i++){
                for(int j=0;j<6;j++){
                    SDL_BlitSurface(carta, 0, pantalla, &rectcarta);
                    rectcarta.x+=96;
                    if(contCartas<datos.numCartas){
                        if(datos.matriz[j][i]==0){
                            contCartas+=2;
                            numero=1+rand()%15;
                            datos.matriz[j][i]=numero;
                            for(Uint32 c=0;c<ocurrencias.size();c++){
                                if(numero==ocurrencias[c]){
                                    c=0;
                                    numero=1+rand()%15;
                                }
                            }
                            datos.matriz[j][i]=numero;
                            ocurrencias.push_back(numero);

                            posduplx=rand()%6;
                            posduply=rand()%3;

                            while(datos.matriz[posduplx][posduply]!=0){
                                 posduplx=rand()%6;
                                 posduply=rand()%3;
                            }
                            datos.matriz[posduplx][posduply]=numero;
                        }
                    }
                }
                rectcarta.x=125;
                rectcarta.y+=152;
            }
            break;
        }
        case 3:{
            rectcarta.x=25;
            rectcarta.y=150;
            SDL_Surface* carta = IMG_Load("../imagenes/cartas/tux.png");
            datos.numCartas=24;
            cont=0;
            //Inicializacion de matriz a 0
            for(int i=0;i<3;i++)
                for(int j=0;j<8;j++)
                    datos.matriz[j][i]=0;
            for(int i=0;i<3;i++){
                for(int j=0;j<8;j++){
                    SDL_BlitSurface(carta, 0, pantalla, &rectcarta);
                    rectcarta.x+=96;
                    if(contCartas<datos.numCartas){
                        if(datos.matriz[j][i]==0){
                            contCartas+=2;
                            numero=1+rand()%15;
                            datos.matriz[j][i]=numero;
                            for(Uint32 c=0;c<ocurrencias.size();c++){
                                if(numero==ocurrencias[c]){
                                    c=0;
                                    numero=1+rand()%15;
                                }
                            }
                            datos.matriz[j][i]=numero;
                            ocurrencias.push_back(numero);

                            posduplx=rand()%8;
                            posduply=rand()%3;

                            while(datos.matriz[posduplx][posduply]!=0){
                                 posduplx=rand()%8;
                                 posduply=rand()%3;
                            }
                            datos.matriz[posduplx][posduply]=numero;
                        }
                    }
                }
                rectcarta.x=25;
                rectcarta.y+=152;
            }
            break;
        }
    }
    
     while(!terminar){
         // Manejo de eventos
        SDL_Event event;
        while(SDL_PollEvent(&event)){
        	//tecl.actualizar();
       		if(event.type==SDL_QUIT){
        		terminar=true;
        		break;
       		 }
                if(event.type==SDL_MOUSEBUTTONDOWN)
                {
                    Uint32 mousex, mousey;
                    mousex=event.button.x;
                    mousey=event.button.y;
                    //Comprobacion btn modo arcade
                    if(mousex>630&&mousey>20&&mousex<(630+150)&&mousey<(20+40)){
                        cout<<"Pulsacion de boton: Salir"<<endl;
                        terminar=true;
                    }
                    //Comprobacion de cartas tamaño 48 x 76
                    if(nivel==1){
                        if(mousex>250&&mousey>150&&mousex<(250+48)&&mousey<(150+76)){
                            rectcarta.x=250;
                            rectcarta.y=150;
                            voltear_carta(pantalla,rectcarta, datos, 0, 0);
                            if(estado==0){
                                estado++;
                                carta_levantada.x=0;
                                carta_levantada.y=0;
                            }
                            else{
                                estado=comprobacion_parejas(pantalla, &datos, carta_levantada, 0, 0, &cartasEmparejadas);
                            }
                        }
                        if(mousex>250&&mousey>302&&mousex<(250+48)&&mousey<(302+76)){
                            rectcarta.x=250;
                            rectcarta.y=302;
                            voltear_carta(pantalla,rectcarta, datos, 0, 1);
                            if(estado==0){
                                estado++;
                                carta_levantada.x=0;
                                carta_levantada.y=1;
                            }
                            else{
                                estado=comprobacion_parejas(pantalla, &datos, carta_levantada, 0, 1, &cartasEmparejadas);
                            }
                        }
                        if(mousex>250&&mousey>454&&mousex<(250+48)&&mousey<(454+76)){
                            rectcarta.x=250;
                            rectcarta.y=454;
                            voltear_carta(pantalla,rectcarta, datos, 0, 2);
                            if(estado==0){
                                estado++;
                                carta_levantada.x=0;
                                carta_levantada.y=2;
                            }
                            else{
                                estado=comprobacion_parejas(pantalla, &datos, carta_levantada, 0, 2, &cartasEmparejadas);
                            }
                        }
                        if(mousex>346&&mousey>150&&mousex<(346+48)&&mousey<(150+76)){
                            rectcarta.x=346;
                            rectcarta.y=150;
                            voltear_carta(pantalla,rectcarta, datos, 1, 0);
                            if(estado==0){
                                estado++;
                                carta_levantada.x=1;
                                carta_levantada.y=0;
                            }
                            else{
                                estado=comprobacion_parejas(pantalla, &datos, carta_levantada, 1, 0, &cartasEmparejadas);
                            }
                        }
                        if(mousex>346&&mousey>302&&mousex<(346+48)&&mousey<(302+76)){
                            rectcarta.x=346;
                            rectcarta.y=302;
                            voltear_carta(pantalla,rectcarta, datos, 1, 1);
                            if(estado==0){
                                estado++;
                                carta_levantada.x=1;
                                carta_levantada.y=1;
                            }
                            else{
                                estado=comprobacion_parejas(pantalla, &datos, carta_levantada, 1, 1, &cartasEmparejadas);
                            }
                        }
                        if(mousex>346&&mousey>454&&mousex<(346+48)&&mousey<(454+76)){
                            rectcarta.x=346;
                            rectcarta.y=454;
                            voltear_carta(pantalla,rectcarta, datos, 1, 2);
                            if(estado==0){
                                estado++;
                                carta_levantada.x=1;
                                carta_levantada.y=2;
                            }
                            else{
                                estado=comprobacion_parejas(pantalla, &datos, carta_levantada, 1, 2, &cartasEmparejadas);
                            }
                        }
                        if(mousex>442&&mousey>150&&mousex<(442+48)&&mousey<(150+76)){
                            rectcarta.x=442;
                            rectcarta.y=150;
                            voltear_carta(pantalla,rectcarta, datos, 2, 0);
                            if(estado==0){
                                estado++;
                                carta_levantada.x=2;
                                carta_levantada.y=0;
                            }
                            else{
                                estado=comprobacion_parejas(pantalla, &datos, carta_levantada, 2, 0, &cartasEmparejadas);
                            }
                        }
                        if(mousex>442&&mousey>302&&mousex<(442+48)&&mousey<(302+76)){
                            rectcarta.x=442;
                            rectcarta.y=302;
                            voltear_carta(pantalla,rectcarta, datos, 2, 1);
                            if(estado==0){
                                estado++;
                                carta_levantada.x=2;
                                carta_levantada.y=1;
                            }
                            else{
                                estado=comprobacion_parejas(pantalla, &datos, carta_levantada, 2, 1, &cartasEmparejadas);
                            }
                        }
                        if(mousex>442&&mousey>454&&mousex<(442+48)&&mousey<(454+76)){
                            rectcarta.x=442;
                            rectcarta.y=454;
                            voltear_carta(pantalla,rectcarta, datos, 2, 2);
                            if(estado==0){
                                estado++;
                                carta_levantada.x=2;
                                carta_levantada.y=2;
                            }
                            else{
                                estado=comprobacion_parejas(pantalla, &datos, carta_levantada, 2, 2, &cartasEmparejadas);
                            }
                        }
                        if(mousex>538&&mousey>150&&mousex<(538+48)&&mousey<(150+76)){
                            rectcarta.x=538;
                            rectcarta.y=150;
                            voltear_carta(pantalla,rectcarta, datos, 3, 0);
                            if(estado==0){
                                estado++;
                                carta_levantada.x=3;
                                carta_levantada.y=0;
                            }
                            else{
                                estado=comprobacion_parejas(pantalla, &datos, carta_levantada, 3, 0, &cartasEmparejadas);
                            }
                        }
                        if(mousex>538&&mousey>302&&mousex<(538+48)&&mousey<(302+76)){
                            rectcarta.x=538;
                            rectcarta.y=302;
                            voltear_carta(pantalla,rectcarta, datos,3, 1);
                            if(estado==0){
                                estado++;
                                carta_levantada.x=3;
                                carta_levantada.y=1;
                            }
                            else{
                                estado=comprobacion_parejas(pantalla, &datos, carta_levantada, 3, 1, &cartasEmparejadas);
                            }
                        }
                        if(mousex>538&&mousey>454&&mousex<(538+48)&&mousey<(454+76)){
                            rectcarta.x=538;
                            rectcarta.y=454;
                            voltear_carta(pantalla,rectcarta, datos, 3, 2);
                            if(estado==0){
                                estado++;
                                carta_levantada.x=3;
                                carta_levantada.y=2;
                            }
                            else{
                                estado=comprobacion_parejas(pantalla, &datos, carta_levantada, 3, 2, &cartasEmparejadas);
                            }
                        }
                    }
                    else if(nivel==2){
                        if(mousex>125&&mousey>150&&mousex<(125+48)&&mousey<(150+76)){
                            rectcarta.x=125;
                            rectcarta.y=150;
                             voltear_carta(pantalla,rectcarta, datos, 0, 0);
                            if(estado==0){
                                estado++;
                                carta_levantada.x=0;
                                carta_levantada.y=0;
                            }
                            else{
                                estado=comprobacion_parejas(pantalla, &datos, carta_levantada, 0, 0, &cartasEmparejadas);
                            }
                        }
                        if(mousex>125&&mousey>302&&mousex<(125+48)&&mousey<(302+76)){
                            rectcarta.x=125;
                            rectcarta.y=302;
                             voltear_carta(pantalla,rectcarta, datos, 0, 1);
                            if(estado==0){
                                estado++;
                                carta_levantada.x=0;
                                carta_levantada.y=1;
                            }
                            else{
                                estado=comprobacion_parejas(pantalla, &datos, carta_levantada, 0, 1,&cartasEmparejadas);
                            }
                        }
                        if(mousex>125&&mousey>454&&mousex<(125+48)&&mousey<(454+76)){
                            rectcarta.x=125;
                            rectcarta.y=454;
                             voltear_carta(pantalla,rectcarta, datos, 0, 2);
                            if(estado==0){
                                estado++;
                                carta_levantada.x=0;
                                carta_levantada.y=2;
                            }
                            else{
                                estado=comprobacion_parejas(pantalla, &datos, carta_levantada, 0, 2, &cartasEmparejadas);
                            }
                        }
                        if(mousex>221&&mousey>150&&mousex<(221+48)&&mousey<(150+76)){
                            rectcarta.x=221;
                            rectcarta.y=150;
                             voltear_carta(pantalla,rectcarta, datos, 1, 0);
                            if(estado==0){
                                estado++;
                                carta_levantada.x=1;
                                carta_levantada.y=0;
                            }
                            else{
                                estado=comprobacion_parejas(pantalla, &datos, carta_levantada, 0, 3, &cartasEmparejadas);
                            }
                        }
                        if(mousex>221&&mousey>302&&mousex<(221+48)&&mousey<(302+76)){
                            rectcarta.x=221;
                            rectcarta.y=302;
                             voltear_carta(pantalla,rectcarta, datos, 1, 1);
                            if(estado==0){
                                estado++;
                                carta_levantada.x=1;
                                carta_levantada.y=1;
                            }
                            else{
                                estado=comprobacion_parejas(pantalla, &datos, carta_levantada, 1, 1, &cartasEmparejadas);
                            }
                        }
                        if(mousex>221&&mousey>454&&mousex<(221+48)&&mousey<(454+76)){
                            rectcarta.x=221;
                            rectcarta.y=454;
                             voltear_carta(pantalla,rectcarta, datos, 1, 2);
                            if(estado==0){
                                estado++;
                                carta_levantada.x=1;
                                carta_levantada.y=2;
                            }
                            else{
                                estado=comprobacion_parejas(pantalla, &datos, carta_levantada, 1, 2, &cartasEmparejadas);
                            }
                        }
                        if(mousex>317&&mousey>150&&mousex<(317+48)&&mousey<(150+76)){
                            rectcarta.x=317;
                            rectcarta.y=150;
                             voltear_carta(pantalla,rectcarta, datos, 2, 0);
                            if(estado==0){
                                estado++;
                                carta_levantada.x=2;
                                carta_levantada.y=0;
                            }
                            else{
                                estado=comprobacion_parejas(pantalla, &datos, carta_levantada, 2, 0, &cartasEmparejadas);
                            }
                        }
                        if(mousex>317&&mousey>302&&mousex<(317+48)&&mousey<(302+76)){
                            rectcarta.x=317;
                            rectcarta.y=302;
                             voltear_carta(pantalla,rectcarta, datos, 2, 1);
                            if(estado==0){
                                estado++;
                                carta_levantada.x=2;
                                carta_levantada.y=1;
                            }
                            else{
                                estado=comprobacion_parejas(pantalla, &datos, carta_levantada, 2, 1, &cartasEmparejadas);
                            }
                        }
                        if(mousex>317&&mousey>454&&mousex<(317+48)&&mousey<(454+76)){
                            rectcarta.x=317;
                            rectcarta.y=454;
                             voltear_carta(pantalla,rectcarta, datos, 2, 2);
                            if(estado==0){
                                estado++;
                                carta_levantada.x=2;
                                carta_levantada.y=2;
                            }
                            else{
                                estado=comprobacion_parejas(pantalla, &datos, carta_levantada, 2, 2, &cartasEmparejadas);
                            }
                        }
                        if(mousex>413&&mousey>150&&mousex<(413+48)&&mousey<(150+76)){
                            rectcarta.x=413;
                            rectcarta.y=150;
                             voltear_carta(pantalla,rectcarta, datos, 3, 0);
                            if(estado==0){
                                estado++;
                                carta_levantada.x=3;
                                carta_levantada.y=0;
                            }
                            else{
                                estado=comprobacion_parejas(pantalla, &datos, carta_levantada, 3, 0, &cartasEmparejadas);
                            }
                        }
                        if(mousex>413&&mousey>302&&mousex<(413+48)&&mousey<(302+76)){
                            rectcarta.x=413;
                            rectcarta.y=302;
                             voltear_carta(pantalla,rectcarta, datos, 3, 1);
                            if(estado==0){
                                estado++;
                                carta_levantada.x=3;
                                carta_levantada.y=1;
                            }
                            else{
                                estado=comprobacion_parejas(pantalla, &datos, carta_levantada, 3, 1, &cartasEmparejadas);
                            }
                        }
                        if(mousex>413&&mousey>454&&mousex<(413+48)&&mousey<(454+76)){
                            rectcarta.x=413;
                            rectcarta.y=454;
                             voltear_carta(pantalla,rectcarta, datos, 3, 2);
                            if(estado==0){
                                estado++;
                                carta_levantada.x=3;
                                carta_levantada.y=2;
                            }
                            else{
                                estado=comprobacion_parejas(pantalla, &datos, carta_levantada, 3, 2, &cartasEmparejadas);
                            }
                        }
                        if(mousex>509&&mousey>150&&mousex<(509+48)&&mousey<(150+76)){
                            rectcarta.x=509;
                            rectcarta.y=150;
                             voltear_carta(pantalla,rectcarta, datos, 4, 0);
                            if(estado==0){
                                estado++;
                                carta_levantada.x=4;
                                carta_levantada.y=0;
                            }
                            else{
                                estado=comprobacion_parejas(pantalla, &datos, carta_levantada, 4, 0, &cartasEmparejadas);
                            }
                        }
                        if(mousex>509&&mousey>302&&mousex<(509+48)&&mousey<(302+76)){
                            rectcarta.x=509;
                            rectcarta.y=302;
                             voltear_carta(pantalla,rectcarta, datos, 4, 1);
                            if(estado==0){
                                estado++;
                                carta_levantada.x=4;
                                carta_levantada.y=1;
                            }
                            else{
                                estado=comprobacion_parejas(pantalla, &datos, carta_levantada, 4, 1, &cartasEmparejadas);
                            }
                        }
                        if(mousex>509&&mousey>454&&mousex<(509+48)&&mousey<(454+76)){
                            rectcarta.x=509;
                            rectcarta.y=454;
                             voltear_carta(pantalla,rectcarta, datos, 4, 2);
                            if(estado==0){
                                estado++;
                                carta_levantada.x=4;
                                carta_levantada.y=2;
                            }
                            else{
                                estado=comprobacion_parejas(pantalla, &datos, carta_levantada, 4, 2, &cartasEmparejadas);
                            }
                        }
                        if(mousex>605&&mousey>150&&mousex<(605+48)&&mousey<(150+76)){
                            rectcarta.x=605;
                            rectcarta.y=150;
                             voltear_carta(pantalla,rectcarta, datos, 5, 0);
                            if(estado==0){
                                estado++;
                                carta_levantada.x=5;
                                carta_levantada.y=0;
                            }
                            else{
                                estado=comprobacion_parejas(pantalla, &datos, carta_levantada, 5, 0, &cartasEmparejadas);
                            }
                        }
                        if(mousex>605&&mousey>302&&mousex<(605+48)&&mousey<(302+76)){
                            rectcarta.x=605;
                            rectcarta.y=302;
                             voltear_carta(pantalla,rectcarta, datos, 5, 1);
                            if(estado==0){
                                estado++;
                                carta_levantada.x=5;
                                carta_levantada.y=1;
                            }
                            else{
                                estado=comprobacion_parejas(pantalla, &datos, carta_levantada, 5, 1, &cartasEmparejadas);
                            }
                        }
                        if(mousex>605&&mousey>454&&mousex<(605+48)&&mousey<(454+76)){
                            rectcarta.x=605;
                            rectcarta.y=454;
                             voltear_carta(pantalla,rectcarta, datos, 5, 2);
                            if(estado==0){
                                estado++;
                                carta_levantada.x=5;
                                carta_levantada.y=2;
                            }
                            else{
                                estado=comprobacion_parejas(pantalla, &datos, carta_levantada, 5, 2, &cartasEmparejadas);
                            }
                        }

                    }
                    else{
                        if(mousex>25&&mousey>150&&mousex<(25+48)&&mousey<(150+76)){
                            rectcarta.x=25;
                            rectcarta.y=150;
                             voltear_carta(pantalla,rectcarta, datos, 0, 0);
                            if(estado==0){
                                estado++;
                                carta_levantada.x=0;
                                carta_levantada.y=0;
                            }
                            else{
                                estado=comprobacion_parejas(pantalla, &datos, carta_levantada, 0, 0, &cartasEmparejadas);
                            }
                        }
                        if(mousex>25&&mousey>302&&mousex<(25+48)&&mousey<(302+76)){
                            rectcarta.x=25;
                            rectcarta.y=302;
                             voltear_carta(pantalla,rectcarta, datos, 0, 1);
                            if(estado==0){
                                estado++;
                                carta_levantada.x=0;
                                carta_levantada.y=1;
                            }
                            else{
                                estado=comprobacion_parejas(pantalla, &datos, carta_levantada, 0, 1, &cartasEmparejadas);
                            }
                        }
                        if(mousex>25&&mousey>454&&mousex<(25+48)&&mousey<(454+76)){
                            rectcarta.x=25;
                            rectcarta.y=454;
                             voltear_carta(pantalla,rectcarta, datos, 0, 2);
                            if(estado==0){
                                estado++;
                                carta_levantada.x=0;
                                carta_levantada.y=2;
                            }
                            else{
                                estado=comprobacion_parejas(pantalla, &datos, carta_levantada, 0, 2, &cartasEmparejadas);
                            }
                        }
                        if(mousex>121&&mousey>150&&mousex<(121+48)&&mousey<(150+76)){
                            rectcarta.x=121;
                            rectcarta.y=150;
                             voltear_carta(pantalla,rectcarta, datos, 1, 0);
                            if(estado==0){
                                estado++;
                                carta_levantada.x=1;
                                carta_levantada.y=0;
                            }
                            else{
                                estado=comprobacion_parejas(pantalla, &datos, carta_levantada, 1, 0, &cartasEmparejadas);
                            }
                        }
                        if(mousex>121&&mousey>302&&mousex<(121+48)&&mousey<(302+76)){
                            rectcarta.x=121;
                            rectcarta.y=302;
                             voltear_carta(pantalla,rectcarta, datos, 1, 1);
                            if(estado==0){
                                estado++;
                                carta_levantada.x=1;
                                carta_levantada.y=1;
                            }
                            else{
                                estado=comprobacion_parejas(pantalla, &datos, carta_levantada, 1, 1, &cartasEmparejadas);
                            }
                        }
                        if(mousex>121&&mousey>454&&mousex<(121+48)&&mousey<(454+76)){
                            rectcarta.x=121;
                            rectcarta.y=454;
                             voltear_carta(pantalla,rectcarta, datos, 1, 2);
                            if(estado==0){
                                estado++;
                                carta_levantada.x=1;
                                carta_levantada.y=2;
                            }
                            else{
                                estado=comprobacion_parejas(pantalla, &datos, carta_levantada, 1, 2, &cartasEmparejadas);
                            }
                        }
                        if(mousex>217&&mousey>150&&mousex<(217+48)&&mousey<(150+76)){
                            rectcarta.x=217;
                            rectcarta.y=150;
                             voltear_carta(pantalla,rectcarta, datos, 2, 0);
                            if(estado==0){
                                estado++;
                                carta_levantada.x=2;
                                carta_levantada.y=0;
                            }
                            else{
                                estado=comprobacion_parejas(pantalla, &datos, carta_levantada, 2, 0, &cartasEmparejadas);
                            }
                        }
                        if(mousex>217&&mousey>302&&mousex<(217+48)&&mousey<(302+76)){
                            rectcarta.x=217;
                            rectcarta.y=302;
                             voltear_carta(pantalla,rectcarta, datos, 2, 1);
                            if(estado==0){
                                estado++;
                                carta_levantada.x=2;
                                carta_levantada.y=1;
                            }
                            else{
                                estado=comprobacion_parejas(pantalla, &datos, carta_levantada, 2, 1, &cartasEmparejadas);
                            }
                        }
                        if(mousex>217&&mousey>454&&mousex<(217+48)&&mousey<(454+76)){
                            rectcarta.x=217;
                            rectcarta.y=454;
                             voltear_carta(pantalla,rectcarta, datos, 2, 2);
                            if(estado==0){
                                estado++;
                                carta_levantada.x=2;
                                carta_levantada.y=2;
                            }
                            else{
                                estado=comprobacion_parejas(pantalla, &datos, carta_levantada, 2, 2, &cartasEmparejadas);
                            }
                        }
                        if(mousex>313&&mousey>150&&mousex<(313+48)&&mousey<(150+76)){
                            rectcarta.x=313;
                            rectcarta.y=150;
                             voltear_carta(pantalla,rectcarta, datos, 3, 0);
                            if(estado==0){
                                estado++;
                                carta_levantada.x=3;
                                carta_levantada.y=0;
                            }
                            else{
                                estado=comprobacion_parejas(pantalla, &datos, carta_levantada, 3, 0, &cartasEmparejadas);
                            }
                        }
                        if(mousex>313&&mousey>302&&mousex<(313+48)&&mousey<(302+76)){
                            rectcarta.x=313;
                            rectcarta.y=302;
                             voltear_carta(pantalla,rectcarta, datos, 3, 1);
                            if(estado==0){
                                estado++;
                                carta_levantada.x=3;
                                carta_levantada.y=1;
                            }
                            else{
                                estado=comprobacion_parejas(pantalla, &datos, carta_levantada, 3, 1, &cartasEmparejadas);
                            }
                        }
                        if(mousex>313&&mousey>454&&mousex<(313+48)&&mousey<(454+76)){
                            rectcarta.x=313;
                            rectcarta.y=454;
                             voltear_carta(pantalla,rectcarta, datos, 3, 2);
                            if(estado==0){
                                estado++;
                                carta_levantada.x=3;
                                carta_levantada.y=2;
                            }
                            else{
                                estado=comprobacion_parejas(pantalla, &datos, carta_levantada, 3, 2, &cartasEmparejadas);
                            }
                        }
                        if(mousex>409&&mousey>150&&mousex<(409+48)&&mousey<(150+76)){
                            rectcarta.x=409;
                            rectcarta.y=150;
                             voltear_carta(pantalla,rectcarta, datos, 4, 0);
                            if(estado==0){
                                estado++;
                                carta_levantada.x=4;
                                carta_levantada.y=0;
                            }
                            else{
                                estado=comprobacion_parejas(pantalla, &datos, carta_levantada, 4, 0, &cartasEmparejadas);
                            }
                        }
                        if(mousex>409&&mousey>302&&mousex<(409+48)&&mousey<(302+76)){
                            rectcarta.x=409;
                            rectcarta.y=302;
                             voltear_carta(pantalla,rectcarta, datos, 4, 1);
                            if(estado==0){
                                estado++;
                                carta_levantada.x=4;
                                carta_levantada.y=1;
                            }
                            else{
                                estado=comprobacion_parejas(pantalla, &datos, carta_levantada, 4, 1, &cartasEmparejadas);
                            }
                        }
                        if(mousex>409&&mousey>454&&mousex<(409+48)&&mousey<(454+76)){
                            rectcarta.x=409;
                            rectcarta.y=454;
                             voltear_carta(pantalla,rectcarta, datos, 4, 2);
                            if(estado==0){
                                estado++;
                                carta_levantada.x=4;
                                carta_levantada.y=2;
                            }
                            else{
                                estado=comprobacion_parejas(pantalla, &datos, carta_levantada, 4, 2, &cartasEmparejadas);
                            }
                        }
                        if(mousex>505&&mousey>150&&mousex<(505+48)&&mousey<(150+76)){
                            rectcarta.x=505;
                            rectcarta.y=150;
                             voltear_carta(pantalla,rectcarta, datos, 5, 0);
                            if(estado==0){
                                estado++;
                                carta_levantada.x=5;
                                carta_levantada.y=0;
                            }
                            else{
                                estado=comprobacion_parejas(pantalla, &datos, carta_levantada, 5, 0, &cartasEmparejadas);
                            }
                        }
                        if(mousex>505&&mousey>302&&mousex<(505+48)&&mousey<(302+76)){
                            rectcarta.x=505;
                            rectcarta.y=302;
                             voltear_carta(pantalla,rectcarta, datos, 5, 1);
                            if(estado==0){
                                estado++;
                                carta_levantada.x=5;
                                carta_levantada.y=1;
                            }
                            else{
                                estado=comprobacion_parejas(pantalla, &datos, carta_levantada, 5, 1, &cartasEmparejadas);
                            }
                        }
                        if(mousex>505&&mousey>454&&mousex<(505+48)&&mousey<(454+76)){
                            rectcarta.x=505;
                            rectcarta.y=454;
                             voltear_carta(pantalla,rectcarta, datos, 5, 2);
                            if(estado==0){
                                estado++;
                                carta_levantada.x=5;
                                carta_levantada.y=2;
                            }
                            else{
                                estado=comprobacion_parejas(pantalla, &datos, carta_levantada, 5, 2, &cartasEmparejadas);
                            }
                        }
                        if(mousex>601&&mousey>150&&mousex<(601+48)&&mousey<(150+76)){
                            rectcarta.x=601;
                            rectcarta.y=150;
                             voltear_carta(pantalla,rectcarta, datos, 6, 0);
                            if(estado==0){
                                estado++;
                                carta_levantada.x=6;
                                carta_levantada.y=0;
                            }
                            else{
                                estado=comprobacion_parejas(pantalla, &datos, carta_levantada, 6, 0, &cartasEmparejadas);
                            }
                        }
                        if(mousex>601&&mousey>302&&mousex<(601+48)&&mousey<(302+76)){
                            rectcarta.x=601;
                            rectcarta.y=302;
                             voltear_carta(pantalla,rectcarta, datos, 6, 1);
                            if(estado==0){
                                estado++;
                                carta_levantada.x=6;
                                carta_levantada.y=1;
                            }
                            else{
                                estado=comprobacion_parejas(pantalla, &datos, carta_levantada, 6, 1, &cartasEmparejadas);
                            }
                        }
                        if(mousex>601&&mousey>454&&mousex<(601+48)&&mousey<(454+76)){
                            rectcarta.x=601;
                            rectcarta.y=454;
                             voltear_carta(pantalla,rectcarta, datos, 6, 2);
                            if(estado==0){
                                estado++;
                                carta_levantada.x=6;
                                carta_levantada.y=2;
                            }
                            else{
                                estado=comprobacion_parejas(pantalla, &datos, carta_levantada, 6, 2, &cartasEmparejadas);
                            }
                        }
                        if(mousex>697&&mousey>150&&mousex<(697+48)&&mousey<(150+76)){
                            rectcarta.x=697;
                            rectcarta.y=150;
                             voltear_carta(pantalla,rectcarta, datos, 7, 0);
                            if(estado==0){
                                estado++;
                                carta_levantada.x=7;
                                carta_levantada.y=0;
                            }
                            else{
                                estado=comprobacion_parejas(pantalla, &datos, carta_levantada, 7, 0, &cartasEmparejadas);
                            }
                        }
                        if(mousex>697&&mousey>302&&mousex<(697+48)&&mousey<(302+76)){
                            rectcarta.x=697;
                            rectcarta.y=302;
                             voltear_carta(pantalla,rectcarta, datos, 7, 1);
                            if(estado==0){
                                estado++;
                                carta_levantada.x=7;
                                carta_levantada.y=1;
                            }
                            else{
                                estado=comprobacion_parejas(pantalla, &datos, carta_levantada, 7, 1, &cartasEmparejadas);
                            }
                        }
                        if(mousex>697&&mousey>454&&mousex<(697+48)&&mousey<(454+76)){
                            rectcarta.x=697;
                            rectcarta.y=454;
                             voltear_carta(pantalla,rectcarta, datos, 7, 2);
                            if(estado==0){
                                estado++;
                                carta_levantada.x=7;
                                carta_levantada.y=2;
                            }
                            else{
                                estado=comprobacion_parejas(pantalla, &datos, carta_levantada, 7, 2, &cartasEmparejadas);
                            }
                        }
                    }
                }
        }
        if(cartasEmparejadas==datos.numCartas){
            cout<<"Fin de nivel"<<endl;
            if(nivel==3){
                cout<<"Juego terminado"<<endl;
                terminar=true;
                crono.consultartiempo(&min,&seg);
                seg+=min*60;
                return seg;
            }
            else{
                nivel++;
                goto carga;
            }
        }
        if(SDL_GetTicks()-tiempo>1000){
            SDL_FillRect(pantalla, &recttiempo, SDL_MapRGB(pantalla->format,0,0,0));
            crono.actualizartiempo(pantalla);
            tiempo=SDL_GetTicks();
        }
        else{
            crono.dibujatiempo(pantalla);
        }
        SDL_Flip(pantalla);
     }
    return 0;
}
void minijuego::dibujaescenario_diferencias(SDL_Surface *pantalla, SDL_Surface* fig1, SDL_Surface* fig2, SDL_Surface* texto){
    //Imagen de fondo
    SDL_Surface* fondo = IMG_Load("../imagenes/fondos/diferencias.png");
     if(!fondo)
    {
        cerr<<"Imposible cargar imagen: "<< SDL_GetError()<<endl;
        exit(1);
    }
     SDL_BlitSurface(fondo, 0, pantalla, 0);
     //Boton Salir
     SDL_Surface* boton1 = IMG_Load("../imagenes/botones/Salir.png");
    if(!boton1)
    {
        cerr<<"Imposible cargar imagen: "<< SDL_GetError()<<endl;
        exit(1);
    }
    SDL_Rect rectbtn;
    rectbtn.x=630;
    rectbtn.y=20;
    SDL_BlitSurface(boton1, 0, pantalla, &rectbtn);

    SDL_Rect rectfig;
    rectfig.x=33;
    rectfig.y=150;
    SDL_BlitSurface(fig1, 0, pantalla, &rectfig);
    rectfig.x=416;
    rectfig.y=150;
    SDL_BlitSurface(fig2, 0, pantalla, &rectfig);
    
     //Escribimos el texto
    // Renderizamos

    SDL_Rect dest;
    dest.x = 100;
    dest.y = 500;
    SDL_BlitSurface(texto, 0, pantalla, &dest);
}

Uint32 minijuego::diferencias(SDL_Surface * pantalla){
    bool terminar=false;
    FILE* f;
    char mensaje[60];
    reloj crono(700, 550);
    char rutafig1[40], rutafig2[40];
    Uint32 numfig, maxfig, fallosencontrados=0, tiempo=0, min, seg;
    
    //Estructura de datos para las posiciones de los errores
    tipoerrores edfallos;
    //Marcamos todo a false
    for(int i=0;i<10;i++)
        edfallos.marcado[i]=false;
    TTF_Font *fuente;
    SDL_Surface *texto;
    //Cargamos las fuentes
    fuente = TTF_OpenFont("../fuentes/FreeSansBold.ttf", 20);
    if(!fuente)
    {
        cerr<<"Error no se encuentra la fuente: "<<SDL_GetError()<<endl;
        return 1;
    }
    SDL_Color color;
    // Establecemos el color para la fuente
    color.r = 255;
    color.g = 255;
    color.b = 255;
    f=fopen("../imagenes/diferencias/soluciones.dat","r");
    //Lectura de fichero para averiguar el máximo de figuras existentes
    fscanf(f,"%d",&maxfig);
    cout<<"maxfig: "<<maxfig<<endl;
    numfig=1+rand()%maxfig;		//Numero de figura a cargar
    sprintf(rutafig1,"../imagenes/diferencias/%d.bmp",numfig);
    sprintf(rutafig2,"../imagenes/diferencias/%d-2.bmp",numfig);
    //Carga de Imagen 1
    SDL_Surface* fig1=SDL_LoadBMP(rutafig1);
    if(!fig1)
    {
        cerr<<"Imposible cargar bitmap: "<<SDL_GetError()<<endl;
        return 1;
    }
    
    //Carga de imagen 2
    SDL_Surface* fig2=SDL_LoadBMP(rutafig2);
    if(!fig2)
    {
        cerr<<"Imposible cargar bitmap: "<<SDL_GetError()<<endl;
        return 1;
    }
    
    //Bucles para conseguir la informacion de las figuras

    for(Uint32 i=0;i<numfig;i++){
        fscanf(f,"\n----\n");
        fscanf(f,"%d",&edfallos.numdif);
        for(Uint32 j=0;j<edfallos.numdif;j++)
        {
            fscanf(f,"%d %d %d",&edfallos.x[j], &edfallos.y[j], &edfallos.cuadro[j]);
        }
    }
    sprintf(mensaje,"Busca las %d diferencias y marcalas en la imagen de la derecha", edfallos.numdif);
    texto = TTF_RenderText_Blended(fuente, mensaje, color);

    //Cargamos la cruz para marcar las diferencias
    SDL_Surface* cruz=IMG_Load("../imagenes/otros/cruz.png");
    SDL_Rect rectcruz;

    dibujaescenario_diferencias(pantalla,fig1,fig2,texto);
     
    
    
    //Bucle principal deljuego
    while(!terminar){
         // Manejo de eventos
        SDL_Event event;
        while(SDL_PollEvent(&event)){
        	//tecl.actualizar();
       		if(event.type==SDL_QUIT){
        		terminar=true;
        		break;
       		 }
                if(event.type==SDL_MOUSEBUTTONDOWN)
                {
                    Uint32 mousex, mousey;
                    mousex=event.button.x;
                    mousey=event.button.y;
                    //Comprobacion btn Salir
                    if(mousex>630&&mousey>20&&mousex<(630+150)&&mousey<(20+40)){
                        cout<<"Pulsacion de boton: Salir"<<endl;
                        terminar=true;
                    }
                    //Coprobacion de errores
                    for(Uint32 i=0;i<edfallos.numdif;i++){
                        if(mousex>(416+edfallos.x[i])&&mousey>(150+edfallos.y[i])&&mousex<(416+edfallos.x[i]+edfallos.cuadro[i])&&mousey<(150+edfallos.y[i]+edfallos.cuadro[i])){
                            if(edfallos.marcado[i]==false){
                                fallosencontrados++;
                                edfallos.marcado[i]=true;
                                rectcruz.x=edfallos.x[i];
                                rectcruz.y=edfallos.y[i];
                                SDL_BlitSurface(cruz, 0, fig2, &rectcruz);
                                dibujaescenario_diferencias(pantalla, fig1, fig2,texto);
                                crono.dibujatiempo(pantalla);
                            }
                        }
                    }
                    
                }
        }
        if(fallosencontrados==edfallos.numdif){
            SDL_Surface* msgfinal;
            SDL_Rect dest;
            msgfinal = TTF_RenderText_Blended(fuente, "Enhorabuena has encontrado todos los fallos", color);
            dest.x = 180;
            dest.y = 570;
            SDL_BlitSurface(msgfinal, 0, pantalla, &dest);
            SDL_Flip(pantalla);
            SDL_Delay(2000);
            crono.consultartiempo(&min, &seg);
            cout<<"Min: "<<min<<"Seg: "<<seg<<endl;
            min*=60;
            seg+=min;
            return seg;
        }
        if(SDL_GetTicks()-tiempo>1000){
            dibujaescenario_diferencias(pantalla, fig1, fig2,texto);
            crono.actualizartiempo(pantalla);
            tiempo=SDL_GetTicks();
        }
        SDL_Flip(pantalla);
    }
    return 0;
}

minijuego::~minijuego() {
}

