/*###############################################################################
## OpenBTrainer project
##
## Copyright (C) 2009 Jose Luis Falcón Ramírez  jose.falconra@alum.uca.es
##
## This program is free software; you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published by
## the Free Software Foundation; either version 3 of the License, or
## (at your option) any later version.
##
## This program is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.
##
## You should have received a copy of the GNU General Public License
## along with this program; if not, write to the Free Software
## Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
###############################################################################*/


#include "cstdio"
#include "iostream"
#include "SDL/SDL.h"
#include "SDL/SDL_image.h"
#include "SDL/SDL_ttf.h"
#include "perfiles.h"

using namespace std;

perfiles::perfiles() {
    FILE* f=fopen("../perfiles/perfiles.sav","r");
    if(!f){
        cout<<"Fichero de perfiles no encontrado"<<endl;
        cout<<"Creando..."<<endl;
        f=fopen("../perfiles/perfiles.sav","w");
        fprintf(f,"Nuevo\nNuevo\nNuevo\nNuevo");
        fclose(f);
        f=fopen("../perfiles/perfiles.sav","r");
    }
    fscanf(f,"%s\n%s\n%s\n%s",nombperfiles[0], nombperfiles[1], nombperfiles[2], nombperfiles[3]);
    for(Uint32 i=0;i<4;i++)
        cout<<nombperfiles[i]<<endl;
    fclose(f);
    perfilactivo=0;
}

void perfiles::dibujarescenarioeditperfil(SDL_Surface* pantalla){

}

void perfiles::nuevoperfil(SDL_Surface* pantalla){
    char ruta[30];
    char nombre[21];
    Uint32 indicenomb=0;
    int w, h;
    SDL_Rect dest, trozo, desttrozo;
    trozo.x=100;
    trozo.y=200;
    trozo.w=600;
    trozo.h=100;
    desttrozo.x=100;
    desttrozo.y=200;
    bool done=false;
    SDL_Surface* fondo = IMG_Load("../imagenes/fondos/editperfiles.png");
     if(!fondo)
    {
        cerr<<"Imposible cargar imagen: "<< SDL_GetError()<<endl;
        exit(1);
    }
    SDL_BlitSurface(fondo, 0, pantalla, 0);
    //Cargamos los tipos de letras
    TTF_Font *fuente;
    fuente = TTF_OpenFont("../fuentes/FreeSansBold.ttf", 30);
    if(!fuente)
    {
        cerr<<"Error no se encuentra la fuente: "<<SDL_GetError()<<endl;
        exit(1);
    }
    //Cargamos el numero a recordar
    SDL_Surface *texto;
    SDL_Color color;
    // Establecemos el color para la fuente
    color.r = 255;
    color.g = 255;
    color.b = 255;
    while (!done)
    {
        // Manejo de eventos
        SDL_Event event;
        while(SDL_PollEvent(&event)){
        	//tecl.actualizar();
       		if(event.type==SDL_QUIT){
        		done=true;
        		break;
       		 }
                if(event.type==SDL_KEYDOWN)
                {
                    if(event.key.keysym.sym==SDLK_RETURN){
                        done=true;
                    }
                    else if(event.key.keysym.sym==SDLK_BACKSPACE){
                        if(indicenomb!=0){
                            indicenomb--;
                            nombre[indicenomb]='\0';
                        }
                        
                    }
                    else{
                        cout<<"Codigo unicode: "<<event.key.keysym.unicode<<endl;
                        if(event.key.keysym.unicode!=0&&event.key.keysym.unicode!=32&&indicenomb<20){        //Evitamos que coja los codigos 0 que corresponden a ctr, mayusculas...  y espacios en blanco
                            nombre[indicenomb]=event.key.keysym.unicode;
                            indicenomb++;
                        }
                    }
                    nombre[indicenomb]='\0';
                    SDL_BlitSurface(fondo, &trozo, pantalla, &desttrozo);
                    TTF_SizeUTF8(fuente, nombre, &w, &h);
                    texto = TTF_RenderText_Blended(fuente, nombre, color);
                    dest.x=400-w/2;
                    dest.y=221-h/2;
                    SDL_BlitSurface(texto, 0, pantalla, &dest);
                }
        }
        SDL_Flip(pantalla);
        SDL_Delay(100);
        
    }
    nombre[indicenomb]='\0';
    cout<<"Nombre: "<<nombre<<endl;
    if(strcmp(nombre,"\0")==0){     //Si el nombre esta vacio
        strcpy(nombre,"Nuevo");
        cout<<"Error: Nombre vacio, no se creo el perfil"<<endl;
        exit(1);
    }
    else{
        strcpy(nombperfiles[perfilactivo], nombre);
        FILE* f=fopen("../perfiles/perfiles.sav","w");
        fprintf(f,"%s\n%s\n%s\n%s",nombperfiles[0], nombperfiles[1], nombperfiles[2], nombperfiles[3]);
        fclose(f);
        sprintf(ruta, "../perfiles/%d.sav",perfilactivo);
        FILE* p=fopen(ruta, "w");
        fprintf(p,"%s\n<--->\n",nombperfiles[perfilactivo]);
        for(Uint32 i=0;i<NUMJUEGOS;i++)
            fprintf(p,"0\n");
        fclose(p);
    }
}

Uint32 perfiles::actualizarpuntuacion(Uint32 perfil, Uint32 numjuego, Uint32 puntuacion, Uint32 tipopuntuacion, SDL_Surface * pantalla){
    Uint32 puntuacionperfil;
    char ruta[30];
    char msgpuntosA[30];
    char msgpuntosD[30];
    char ficheroaux[NUMJUEGOS+2][21];
    int w,h;
    //Cargamos los tipos de letras
    TTF_Font *fuente;
    fuente = TTF_OpenFont("../fuentes/FreeSansBold.ttf", 30);
    if(!fuente)
    {
        cerr<<"Error no se encuentra la fuente: "<<SDL_GetError()<<endl;
        exit(1);
    }
    SDL_Surface *texto;
    SDL_Color color;
    SDL_Rect dest;
    // Establecemos el color para la fuente
    color.r = 255;
    color.g = 255;
    color.b = 255;

    sprintf(ruta, "../perfiles/%d.sav",perfil);
    FILE* f=fopen(ruta,"r");
    if(!f){
        cout<<"Error fichero inexistente"<<endl;
        exit(1);
    }
    for(Uint32 i=0;i<NUMJUEGOS+2;i++){
        fgets(ficheroaux[i],21,f);
    }
    fclose(f);
    sscanf(ficheroaux[numjuego+1],"%d",&puntuacionperfil);
    //Si la puntuacion anterior es mayor que la obtenida no se almacena en el fichero
    if(tipopuntuacion==1){
        if(puntuacionperfil<puntuacion){        //Se batió el record    Si la puntuacion es de tipo nivel y hay que conseguir mayor puntuacion
            f=fopen(ruta,"w");
            for(Uint32 i=0;i<NUMJUEGOS+2;i++)
                if(i==numjuego+1)
                    fprintf(f,"%d\n",puntuacion);       
                else{
                    fprintf(f,"%s",ficheroaux[i]);      
                }
            fclose(f);
            SDL_Surface* fondo = IMG_Load("../imagenes/fondos/enhorabuena.png");
            if(!fondo)
            {
                cerr<<"Imposible cargar imagen: "<< SDL_GetError()<<endl;
                exit(1);
            }
            SDL_BlitSurface(fondo, 0, pantalla, 0);
            TTF_SizeUTF8(fuente, nombperfiles[perfilactivo], &w, &h);
            texto = TTF_RenderText_Blended(fuente, nombperfiles[perfilactivo], color);
            dest.x=400-w/2;     //Centramos el nombre del perfil
            dest.y=245;
            SDL_BlitSurface(texto,0,pantalla,&dest);
            sprintf(msgpuntosA,"Nivel %d", puntuacionperfil);
            texto = TTF_RenderText_Blended(fuente, msgpuntosA , color);
            dest.x=383;
            dest.y=387;
            SDL_BlitSurface(texto,0,pantalla,&dest);
            sprintf(msgpuntosD,"Nivel %d", puntuacion);
            texto = TTF_RenderText_Blended(fuente, msgpuntosD , color);
            dest.x=383;
            dest.y=454;
            SDL_BlitSurface(texto,0,pantalla,&dest);
            SDL_Flip(pantalla);
            SDL_Delay(4000);
            return puntuacion;
        }
        else{           //No se batio el record
            SDL_Surface* fondo = IMG_Load("../imagenes/fondos/sigue.png");
            if(!fondo)
            {
                cerr<<"Imposible cargar imagen: "<< SDL_GetError()<<endl;
                exit(1);
            }
            SDL_BlitSurface(fondo, 0, pantalla, 0);
            TTF_SizeUTF8(fuente, nombperfiles[perfilactivo], &w, &h);
            texto = TTF_RenderText_Blended(fuente, nombperfiles[perfilactivo], color);
            dest.x=400-w/2;     //Centramos el nombre del perfil
            dest.y=245;
            SDL_BlitSurface(texto,0,pantalla,&dest);
            sprintf(msgpuntosA,"Nivel %d", puntuacionperfil);
            texto = TTF_RenderText_Blended(fuente, msgpuntosA , color);
            dest.x=383;
            dest.y=387;
            SDL_BlitSurface(texto,0,pantalla,&dest);
            sprintf(msgpuntosD,"Nivel %d", puntuacion);
            texto = TTF_RenderText_Blended(fuente, msgpuntosD , color);
            dest.x=383;
            dest.y=454;
            SDL_BlitSurface(texto,0,pantalla,&dest);
            SDL_Flip(pantalla);
            SDL_Delay(4000);
            return puntuacionperfil;
        }
    }
    else if(tipopuntuacion==2){
        if(puntuacion!=0){
            if(puntuacionperfil>puntuacion||puntuacionperfil==0){    //Se batio el record    Si la puntuacion es de tipo tiempo y hay que conseguir menor tiempo
                f=fopen(ruta,"w");
                for(Uint32 i=0;i<NUMJUEGOS+2;i++)
                    if(i==numjuego+1)
                        fprintf(f,"%d\n",puntuacion);
                    else{
                        fprintf(f,"%s",ficheroaux[i]);
                    }
                fclose(f);
                SDL_Surface* fondo = IMG_Load("../imagenes/fondos/enhorabuena.png");
                if(!fondo)
                {
                    cerr<<"Imposible cargar imagen: "<< SDL_GetError()<<endl;
                    exit(1);
                }
                SDL_BlitSurface(fondo, 0, pantalla, 0);
                TTF_SizeUTF8(fuente, nombperfiles[perfilactivo], &w, &h);
                texto = TTF_RenderText_Blended(fuente, nombperfiles[perfilactivo], color);
                dest.x=400-w/2;     //Centramos el nombre del perfil
                dest.y=245;
                SDL_BlitSurface(texto,0,pantalla,&dest);
                sprintf(msgpuntosA,"Tiempo %d:%d", puntuacionperfil/60, puntuacionperfil%60);
                texto = TTF_RenderText_Blended(fuente, msgpuntosA , color);
                dest.x=383;
                dest.y=387;
                SDL_BlitSurface(texto,0,pantalla,&dest);
                sprintf(msgpuntosD,"Tiempo %d:%d", puntuacion/60, puntuacion%60);
                texto = TTF_RenderText_Blended(fuente, msgpuntosD , color);
                dest.x=383;
                dest.y=454;
                SDL_BlitSurface(texto,0,pantalla,&dest);
                SDL_Flip(pantalla);
                SDL_Delay(4000);
                return puntuacion;
            }
            else{       //No se batio el record
                SDL_Surface* fondo = IMG_Load("../imagenes/fondos/sigue.png");
                if(!fondo)
                {
                    cerr<<"Imposible cargar imagen: "<< SDL_GetError()<<endl;
                    exit(1);
                }
                SDL_BlitSurface(fondo, 0, pantalla, 0);
                TTF_SizeUTF8(fuente, nombperfiles[perfilactivo], &w, &h);
                texto = TTF_RenderText_Blended(fuente, nombperfiles[perfilactivo], color);
                dest.x=400-w/2;     //Centramos el nombre del perfil
                dest.y=245;
                SDL_BlitSurface(texto,0,pantalla,&dest);
                sprintf(msgpuntosA,"Tiempo %d:%d", puntuacionperfil/60, puntuacionperfil%60);
                texto = TTF_RenderText_Blended(fuente, msgpuntosA , color);
                dest.x=383;
                dest.y=387;
                SDL_BlitSurface(texto,0,pantalla,&dest);
                sprintf(msgpuntosD,"Tiempo %d:%d", puntuacion/60, puntuacion%60);
                texto = TTF_RenderText_Blended(fuente, msgpuntosD , color);
                dest.x=383;
                dest.y=454;
                SDL_BlitSurface(texto,0,pantalla,&dest);
                SDL_Flip(pantalla);
                SDL_Delay(4000);
                return puntuacionperfil;
            }
        }
    }
    else{           //Puntuacion de tipo puntos (Arcade)
        if(puntuacionperfil<puntuacion){        //Se batió el record    Si la puntuacion es de tipo puntos y hay que conseguir mayor puntuacion
            f=fopen(ruta,"w");
            for(Uint32 i=0;i<NUMJUEGOS+2;i++)
                if(i==numjuego+1)
                    fprintf(f,"%d\n",puntuacion);
                else{
                    fprintf(f,"%s",ficheroaux[i]);
                }
            fclose(f);
            SDL_Surface* fondo = IMG_Load("../imagenes/fondos/enhorabuena.png");
            if(!fondo)
            {
                cerr<<"Imposible cargar imagen: "<< SDL_GetError()<<endl;
                exit(1);
            }
            SDL_BlitSurface(fondo, 0, pantalla, 0);
            TTF_SizeUTF8(fuente, nombperfiles[perfilactivo], &w, &h);
            texto = TTF_RenderText_Blended(fuente, nombperfiles[perfilactivo], color);
            dest.x=400-w/2;     //Centramos el nombre del perfil
            dest.y=245;
            SDL_BlitSurface(texto,0,pantalla,&dest);
            sprintf(msgpuntosA,"%d Puntos", puntuacionperfil);
            texto = TTF_RenderText_Blended(fuente, msgpuntosA , color);
            dest.x=383;
            dest.y=387;
            SDL_BlitSurface(texto,0,pantalla,&dest);
            sprintf(msgpuntosD,"%d Puntos", puntuacion);
            texto = TTF_RenderText_Blended(fuente, msgpuntosD , color);
            dest.x=383;
            dest.y=454;
            SDL_BlitSurface(texto,0,pantalla,&dest);
            SDL_Flip(pantalla);
            SDL_Delay(4000);
            return puntuacion;
        }
        else{           //No se batio el record
            SDL_Surface* fondo = IMG_Load("../imagenes/fondos/sigue.png");
            if(!fondo)
            {
                cerr<<"Imposible cargar imagen: "<< SDL_GetError()<<endl;
                exit(1);
            }
            SDL_BlitSurface(fondo, 0, pantalla, 0);
            TTF_SizeUTF8(fuente, nombperfiles[perfilactivo], &w, &h);
            texto = TTF_RenderText_Blended(fuente, nombperfiles[perfilactivo], color);
            dest.x=400-w/2;     //Centramos el nombre del perfil
            dest.y=245;
            SDL_BlitSurface(texto,0,pantalla,&dest);
            sprintf(msgpuntosA,"%d Puntos", puntuacionperfil);
            texto = TTF_RenderText_Blended(fuente, msgpuntosA , color);
            dest.x=383;
            dest.y=387;
            SDL_BlitSurface(texto,0,pantalla,&dest);
            sprintf(msgpuntosD,"%d Puntos", puntuacion);
            texto = TTF_RenderText_Blended(fuente, msgpuntosD , color);
            dest.x=383;
            dest.y=454;
            SDL_BlitSurface(texto,0,pantalla,&dest);
            SDL_Flip(pantalla);
            SDL_Delay(4000);
            return puntuacionperfil;
        }
    }
    return puntuacionperfil;
}
void perfiles::dibujarescenarioperfil(SDL_Surface* pantalla){
    int w,h;
    SDL_Rect dest;
    SDL_Surface* fondo = IMG_Load("../imagenes/fondos/perfiles.png");
     if(!fondo)
    {
        cerr<<"Imposible cargar imagen: "<< SDL_GetError()<<endl;
        exit(1);
    }
    SDL_BlitSurface(fondo, 0, pantalla, 0);
        SDL_Surface* boton1 = IMG_Load("../imagenes/botones/Salir.png");
     if(!boton1)
    {
        cerr<<"Imposible cargar imagen: "<< SDL_GetError()<<endl;
        exit(1);
    }
    SDL_Rect rectbtn;
    rectbtn.x=630;
    rectbtn.y=20;
    SDL_BlitSurface(boton1, 0, pantalla, &rectbtn);
    //Cargamos los tipos de letras
    TTF_Font *fuente;
    fuente = TTF_OpenFont("../fuentes/FreeSansBold.ttf", 30);
    if(!fuente)
    {
        cerr<<"Error no se encuentra la fuente: "<<SDL_GetError()<<endl;
        exit(1);
    }
    //Cargamos el numero a recordar
    SDL_Surface *texto;
    SDL_Color color;
    // Establecemos el color para la fuente
    color.r = 255;
    color.g = 255;
    color.b = 255;
    TTF_SizeUTF8(fuente, nombperfiles[0], &w, &h);
    texto = TTF_RenderText_Blended(fuente, nombperfiles[0], color);
    dest.x=230-w/2;
    dest.y=221-h/2;
    SDL_BlitSurface(texto, 0, pantalla, &dest);
    TTF_SizeUTF8(fuente, nombperfiles[1], &w, &h);
    texto = TTF_RenderText_Blended(fuente, nombperfiles[1], color);
    dest.x=570-w/2;
    dest.y=221-h/2;
    SDL_BlitSurface(texto, 0, pantalla, &dest);
    TTF_SizeUTF8(fuente, nombperfiles[2], &w, &h);
    texto = TTF_RenderText_Blended(fuente, nombperfiles[2], color);
    dest.x=230-w/2;
    dest.y=377-h/2;
    SDL_BlitSurface(texto, 0, pantalla, &dest);
    TTF_SizeUTF8(fuente, nombperfiles[3], &w, &h);
    texto = TTF_RenderText_Blended(fuente, nombperfiles[3], color);
    dest.x=570-w/2;
    dest.y=377-h/2;
    SDL_BlitSurface(texto, 0, pantalla, &dest);
}

void perfiles::cargar(SDL_Surface* pantalla){
    bool done=false;
    dibujarescenarioperfil(pantalla);
    while (!done)
    {
        // Manejo de eventos
        SDL_Event event;
        while(SDL_PollEvent(&event)){
        	//tecl.actualizar();
       		if(event.type==SDL_QUIT){
        		done=true;
        		break;
       		 }
                if(event.type==SDL_MOUSEBUTTONDOWN)
                {
                    Uint32 mousex, mousey;
                    mousex=event.button.x;
                    mousey=event.button.y;
                    if(mousex>630&&mousey>20&&mousex<(630+150)&&mousey<(20+40)){
                        cout<<"Pulsacion de boton: Salir"<<endl;
                        exit(1);
                    }
                    if(mousex>62&&mousey>153&&mousex<(62+279)&&mousey<(153+136)){
                        cout<<"Pulsacion de boton: Perfil1"<<endl;
                        perfilactivo=0;
                        if(strcmp(nombperfiles[perfilactivo],"Nuevo")==0){
                            nuevoperfil(pantalla);
                        }
                        done=true;
                    }
                    if(mousex>411&&mousey>153&&mousex<(411+279)&&mousey<(153+136)){
                        cout<<"Pulsacion de boton: Perfil2"<<endl;
                        perfilactivo=1;
                        if(strcmp(nombperfiles[perfilactivo],"Nuevo")==0){
                            nuevoperfil(pantalla);
                        }
                        done=true;
                    }
                    if(mousex>62&&mousey>309&&mousex<(62+279)&&mousey<(309+136)){
                        cout<<"Pulsacion de boton: Perfil3"<<endl;
                        perfilactivo=2;
                        if(strcmp(nombperfiles[perfilactivo],"Nuevo")==0){
                            nuevoperfil(pantalla);
                        }
                        done=true;
                    }
                    if(mousex>411&&mousey>309&&mousex<(411+279)&&mousey<(309+136)){
                        cout<<"Pulsacion de boton: Perfil4"<<endl;
                        perfilactivo=3;
                        if(strcmp(nombperfiles[perfilactivo],"Nuevo")==0){
                            nuevoperfil(pantalla);
                        }
                        done=true;
                    }

                }
        }
        SDL_Flip(pantalla);
    }
}

void perfiles::nombreperfilactual(char* nombre){
    strcpy(nombre,nombperfiles[perfilactivo]);
}

Uint32 perfiles::perfilactual(){
    return perfilactivo;
}

void perfiles::borrarperfil(){
    char ruta[30];
    cout<<"Perfil Activo: "<<perfilactivo<<endl;
    sprintf(ruta,"../perfiles/%d.sav",perfilactivo);
    unlink(ruta);
    strcpy(nombperfiles[perfilactivo], "Nuevo");
    FILE* f=fopen("../perfiles/perfiles.sav","w");
    fprintf(f,"%s\n%s\n%s\n%s",nombperfiles[0], nombperfiles[1], nombperfiles[2], nombperfiles[3]);
    fclose(f);
}
perfiles::~perfiles() {
}

