/*###############################################################################
## OpenBTrainer project
##
## Copyright (C) 2009 Jose Luis Falcón Ramírez  jose.falconra@alum.uca.es
##
## This program is free software; you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published by
## the Free Software Foundation; either version 3 of the License, or
## (at your option) any later version.
##
## This program is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.
##
## You should have received a copy of the GNU General Public License
## along with this program; if not, write to the Free Software
## Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
###############################################################################*/

#include <SDL/SDL.h>
#include <SDL/SDL_image.h>
#include <SDL/SDL_ttf.h>
#include <stdlib.h>
#include <cmath>
#include <iostream>
#include "rapidez.h"

using namespace std;

rapidez::rapidez() {
    srand(time(0));
}

rapidez::rapidez(const rapidez& orig) {
}

void rapidez::dibujaescenariorec(SDL_Surface *pantalla)
{
    SDL_FillRect(pantalla,NULL,SDL_MapRGB(pantalla->format,0,0,0));
    //Cargamos la imagen de fondo
    SDL_Surface* bmp = IMG_Load("../imagenes/fondos/recuerda.png");
    if (!bmp)
    {
        cerr<<"Imposible cargar imagen: "<< SDL_GetError()<<endl;
        exit(1);
    }
    SDL_BlitSurface(bmp,0,pantalla,0);
    SDL_Surface* boton1 = IMG_Load("../imagenes/botones/Salir.png");
     if(!boton1)
    {
        cerr<<"Imposible cargar imagen: "<< SDL_GetError()<<endl;
        exit(1);
    }
    SDL_Rect rectbtn;
    rectbtn.x=630;
    rectbtn.y=20;
    SDL_BlitSurface(boton1, 0, pantalla, &rectbtn);
}

void rapidez::dibujanumerorec(Uint32 numero, bool principal, SDL_Surface* pantalla){
    if(numero!=0){
        char cadena[100]; //Cadena con el numero generado automaticamente
        int w, h;
        //Cargamos los tipos de letras
        TTF_Font *fuente;
        fuente = TTF_OpenFont("../fuentes/FreeSansBold.ttf", 30);
        if(!fuente)
        {
            cerr<<"Error no se encuentra la fuente: "<<SDL_GetError()<<endl;
            exit(1);
        }
        //Cargamos el numero a recordar
        SDL_Surface *texto;
        SDL_Color color;
        // Establecemos el color para la fuente
        color.r = 255;
        color.g = 255;
        color.b = 255;
        sprintf(cadena,"%d",numero);
        TTF_SizeUTF8(fuente, cadena, &w, &h);
        texto = TTF_RenderText_Blended(fuente, cadena, color);
        SDL_Rect dest;

        //Centramos horizontalmente el texto
        dest.x = 400-(w/2);
        if(principal)
            dest.y = 250;
        else
           dest.y=350;
        SDL_BlitSurface(texto, 0, pantalla, &dest);
    }
}
Uint32 potencia(Uint32 num1, Uint32 exponente){
    Uint32 res=1;
    for(Uint32 i=0;i<exponente;i++)
        res*=num1;
    return res;
}

Uint32 rapidez::generanumerorec(Uint32 nivel){
    Uint32 numero, max=potencia(10,nivel),min=max/10;
    //Con esto conseguimos acotar el numero que genera eliminando los numeros que empiezan por 0 y por tanto con menos cifras
    numero=min+rand()%(max-min+1);
    return numero;
}



Uint32 rapidez::recuerda(SDL_Surface* pantalla){
    bool done=false, nivelaumentado=false;
    char cifras[100]; //Cadena en la que el usuario introducirá su resultado
    Uint32 indicecif=0, numobtenido; //Numero que ira generando cada vez que el usuario pulse en un numero
    Uint32 numero;
    Uint32 nivel=2;
    dibujaescenariorec(pantalla);
    numero=generanumerorec(nivel);
    dibujanumerorec(numero, true, pantalla);
    SDL_Flip(pantalla);
    //Tiempo para memorizar el numero generado
    SDL_Delay(2000);
    dibujaescenariorec(pantalla);
    //Inicializamos las cifras con aes para que no las coja el sscanf con el %d
    for(int i=0; i<100; i++)
        cifras[i]='a';
    //Bucle de minijuegos
    while (!done)
    {
        // Manejo de eventos
        SDL_Event event;
        while(SDL_PollEvent(&event)){
        	//tecl.actualizar();
       		if(event.type==SDL_QUIT){
        		done=true;
        		break;
       		 }
                if(event.type==SDL_MOUSEBUTTONDOWN)
                {
                    Uint32 mousex, mousey;
                    mousex=event.button.x;
                    mousey=event.button.y;
                    //Comprobacion btn modo arcade
                    if(mousex>630&&mousey>20&&mousex<(630+150)&&mousey<(20+40)){
                        cout<<"Pulsacion de boton: Salir"<<endl;
                        done=true;
                    }
                }
                if(event.type==SDL_KEYDOWN)
                {
                    switch(event.key.keysym.sym){
                        case SDLK_BACKSPACE:{
                            if(indicecif!=0){
                                indicecif--;
                                cifras[indicecif]='a';
                                numobtenido/=10;
                            }
                        }
                        break;
                        case SDLK_1:{
                            cifras[indicecif]='1';
                            sscanf(cifras,"%d",&numobtenido);
                            indicecif++;
                        }
                        break;
                        case SDLK_KP1:{
                            cifras[indicecif]='1';
                            sscanf(cifras,"%d",&numobtenido);
                            indicecif++;
                        }
                        break;
                        case SDLK_2:{
                            cifras[indicecif]='2';
                            sscanf(cifras,"%d",&numobtenido);
                            indicecif++;
                        }
                        break;
                        case SDLK_KP2:{
                            cifras[indicecif]='2';
                            sscanf(cifras,"%d",&numobtenido);
                            indicecif++;
                        }
                        break;
                        case SDLK_3:{
                            cifras[indicecif]='3';
                            sscanf(cifras,"%d",&numobtenido);
                            indicecif++;
                        }
                        break;
                        case SDLK_KP3:{
                            cifras[indicecif]='3';
                            sscanf(cifras,"%d",&numobtenido);
                            indicecif++;
                        }
                        break;
                        case SDLK_4:{
                            cifras[indicecif]='4';
                            sscanf(cifras,"%d",&numobtenido);
                            indicecif++;
                        }
                        break;
                        case SDLK_KP4:{
                            cifras[indicecif]='4';
                            sscanf(cifras,"%d",&numobtenido);
                            indicecif++;
                        }
                        break;
                        case SDLK_5:{
                            cifras[indicecif]='5';
                            sscanf(cifras,"%d",&numobtenido);
                            indicecif++;
                        }
                        break;
                        case SDLK_KP5:{
                            cifras[indicecif]='5';
                            sscanf(cifras,"%d",&numobtenido);
                            indicecif++;
                        }
                        break;
                        case SDLK_6:{
                            cifras[indicecif]='6';
                            sscanf(cifras,"%d",&numobtenido);
                            indicecif++;
                        }
                        break;
                        case SDLK_KP6:{
                            cifras[indicecif]='6';
                            sscanf(cifras,"%d",&numobtenido);
                            indicecif++;
                        }
                        break;
                        case SDLK_7:{
                            cifras[indicecif]='7';
                            sscanf(cifras,"%d",&numobtenido);
                            indicecif++;
                        }
                        break;
                        case SDLK_KP7:{
                            cifras[indicecif]='7';
                            sscanf(cifras,"%d",&numobtenido);
                            indicecif++;
                        }

                        break;
                        case SDLK_8:{
                            cifras[indicecif]='8';
                            sscanf(cifras,"%d",&numobtenido);
                            indicecif++;
                        }
                        break;
                        case SDLK_KP8:{
                            cifras[indicecif]='8';
                            sscanf(cifras,"%d",&numobtenido);
                            indicecif++;
                        }
                        break;
                        case SDLK_9:{
                            cifras[indicecif]='9';
                            sscanf(cifras,"%d",&numobtenido);
                            indicecif++;
                        }
                        break;
                        case SDLK_KP9:{
                            cifras[indicecif]='9';
                            sscanf(cifras,"%d",&numobtenido);
                            indicecif++;
                        }
                        break;
                        case SDLK_0:{
                            cifras[indicecif]='0';
                            sscanf(cifras,"%d",&numobtenido);
                            indicecif++;
                        }
                        break;
                        case SDLK_KP0:{
                            cifras[indicecif]='0';
                            sscanf(cifras,"%d",&numobtenido);
                            indicecif++;
                        }
                        break;
                        default:cout<<"Tecla incorrecta"<<endl;
                            break;
                            
                    }
                    if(numobtenido==numero){
                        cout<<"Correcto"<<endl;
                        dibujanumerorec(numero, true, pantalla);
                        nivel++;
                        numero=generanumerorec(nivel);
                        dibujaescenariorec(pantalla);
                        dibujanumerorec(numero, true, pantalla);
                        nivelaumentado=true;
                        indicecif=0;
                        for(int i=0; i<100; i++)
                            cifras[i]='a';
                    }
                    //Aqui comprobamos que el numero, si tiene el mismo número de cifras que la solucion y no es éste, es incorrecto
                    else if((numobtenido/potencia(10, nivel-1))>=1){
                        cout<<"Incorrecto"<<endl<<"Juego Finalizado"<<endl;
                        done=true;
                        dibujaescenariorec(pantalla);
                        dibujanumerorec(numero, true, pantalla);
                        dibujanumerorec(numobtenido, false, pantalla);
                    }
                    else{
                        dibujaescenariorec(pantalla);
                        dibujanumerorec(numobtenido, false, pantalla);
                    }
                }
        }
        SDL_Flip(pantalla);
        if(nivelaumentado){
            nivelaumentado=false;
            SDL_Delay(2000);
            dibujaescenariorec(pantalla);
        }
    }
    SDL_Delay(2000);
    cout<<"Nivel maximo obtenido: "<<nivel<<endl;
    //Aqui devolveriamos la puntuacion obtenida por el jugador
    return nivel;
}

void rapidez::dibujaescenarioobs(SDL_Surface* pantalla){
    SDL_FillRect(pantalla,NULL,SDL_MapRGB(pantalla->format,0,0,0));
    //Cargamos la imagen de fondo
    SDL_Surface* bmp = IMG_Load("../imagenes/fondos/observacion.png");
    if (!bmp)
    {
        cerr<<"Imposible cargar imagen: "<< SDL_GetError()<<endl;
        exit(1);
    }
    SDL_BlitSurface(bmp,0,pantalla,0);
    SDL_Surface* boton1 = IMG_Load("../imagenes/botones/Salir.png");
     if(!boton1)
    {
        cerr<<"Imposible cargar imagen: "<< SDL_GetError()<<endl;
        exit(1);
    }
    SDL_Rect rectbtn;
    rectbtn.x=630;
    rectbtn.y=20;
    SDL_BlitSurface(boton1, 0, pantalla, &rectbtn);
}
Uint32 rapidez::dibujaflechas(Uint32 nivel, Uint32 flecha, SDL_Surface* pantalla){
    Uint32 pos, sigflecha=flecha, contflecha=0;//En contador flecha vamos controlando el numero de veces que se repite la flecha a preguntar
    char ruta[40];
    bool poslibres[8];  //Controlamos que la posicion no esté ocupada
    for(Uint32 i=0;i<8;i++){
        poslibres[i]=true;
    }
    sprintf(ruta, "../imagenes/otros/flecha%d.png",flecha);
    SDL_Surface* flecha1 = IMG_Load(ruta);
     if(!flecha1)
    {
        cerr<<"Imposible cargar imagen: "<< SDL_GetError()<<endl;
        exit(1);
    }
    SDL_Rect rectflecha;
    
    if(nivel==2){
            //Cargamos la otra flecha
            while(sigflecha==flecha){
                sigflecha=1+rand()%4;
            }
            sprintf(ruta, "../imagenes/otros/flecha%d.png",sigflecha);
            SDL_Surface* flecha2 = IMG_Load(ruta);
            if(!flecha2)
            {
                cerr<<"Imposible cargar Imagen: "<< SDL_GetError()<<endl;
                exit(1);
            }
            //Posicion de la flecha a preguntar
            pos=rand()%2;
            if(pos==0){
                rectflecha.x=350;
                rectflecha.y=200;
                SDL_BlitSurface(flecha1, 0, pantalla, &rectflecha);
                rectflecha.y=280;
                SDL_BlitSurface(flecha2, 0, pantalla, &rectflecha);
            }
            else{
                rectflecha.x=350;
                rectflecha.y=280;
                SDL_BlitSurface(flecha1, 0, pantalla, &rectflecha);
                rectflecha.y=200;
                SDL_BlitSurface(flecha2, 0, pantalla, &rectflecha);
            }
           return 1; 
        }
    else{
        //Metemos al menos una flecha de las elegidas
        contflecha++;
        //Cargamos la imagen de la flecha
        sprintf(ruta, "../imagenes/otros/flecha%d.png",flecha);
        SDL_Surface* flecha1 = IMG_Load(ruta);
        if(!flecha1)
        {
            cerr<<"Imposible cargar Imagen: "<< SDL_GetError()<<endl;
            exit(1);
        }
        pos=rand()%8;
        poslibres[pos]=false;
        switch(pos){
                case 0:
                    rectflecha.x=133;
                    rectflecha.y=200;
                    break;
                case 1:
                    rectflecha.x=266;
                    rectflecha.y=200;
                    break;
                case 2:
                    rectflecha.x=399;
                    rectflecha.y=200;
                    break;
                case 3:
                    rectflecha.x=532;
                    rectflecha.y=200;
                    break;
                case 4:
                    rectflecha.x=133;
                    rectflecha.y=280;
                    break;
                case 5:
                    rectflecha.x=266;
                    rectflecha.y=280;
                    break;
                case 6:
                    rectflecha.x=399;
                    rectflecha.y=280;
                    break;
                case 7:
                    rectflecha.x=532;
                    rectflecha.y=280;
                    break;
            }
            SDL_BlitSurface(flecha1, 0, pantalla, &rectflecha);
        for(Uint32 cont=1;cont<nivel;cont++){
            //Cargamos flecha
            sigflecha=1+rand()%4;
            if(sigflecha==flecha)
                contflecha++;
            //La colocamos en su posicion
            pos=rand()%8;
            while(poslibres[pos]==false)
                pos=rand()%8;
            poslibres[pos]=false;
            //Cargamos la imagen de la flecha
            sprintf(ruta, "../imagenes/otros/flecha%d.png",sigflecha);
            SDL_Surface* flecha2 = IMG_Load(ruta);
            if(!flecha2)
            {
                cerr<<"Imposible cargar Imagen: "<< SDL_GetError()<<endl;
                exit(1);
            }
            //Le asignamos unas coordenadas segun la posicion que ha obtenido
            switch(pos){
                case 0:
                    rectflecha.x=133;
                    rectflecha.y=200;
                    break;
                case 1:
                    rectflecha.x=266;
                    rectflecha.y=200;
                    break;
                case 2:
                    rectflecha.x=399;
                    rectflecha.y=200;
                    break;
                case 3:
                    rectflecha.x=532;
                    rectflecha.y=200;
                    break;
                case 4:
                    rectflecha.x=133;
                    rectflecha.y=280;
                    break;
                case 5:
                    rectflecha.x=266;
                    rectflecha.y=280;
                    break;
                case 6:
                    rectflecha.x=399;
                    rectflecha.y=280;
                    break;
                case 7:
                    rectflecha.x=532;
                    rectflecha.y=280;
                    break;
            }
            SDL_BlitSurface(flecha2, 0, pantalla, &rectflecha);
        }
    }
    return contflecha;

}

void rapidez::preguntarflechas(Uint32 flecha, SDL_Surface* pantalla){
    SDL_Rect rectmsg, rectflecha;
    int w, h;
    char ruta[40];
    //Cargamos los tipos de letras
    TTF_Font *fuente;
    fuente = TTF_OpenFont("../fuentes/FreeSansBold.ttf", 20);
    if(!fuente)
    {
        cerr<<"Error no se encuentra la fuente: "<<SDL_GetError()<<endl;
        exit(1);
    }
    //Cargamos el numero a recordar
    SDL_Surface *texto;
    SDL_Color color;
    // Establecemos el color para la fuente
    color.r = 255;
    color.g = 255;
    color.b = 255;
    //Cálculo de la posicion centrada para el texto
    TTF_SizeUTF8(fuente, "Indica la cantidad de flechas del tipo ", &w, &h);
    w+=50;   //Le sumamos la anchura de la flecha
    w/=2;
    rectflecha.x=380+w;
    w=400-w;

    texto = TTF_RenderText_Blended(fuente, "Indica la cantidad de flechas del tipo ", color);
    rectmsg.x=w;
    rectmsg.y=500;
    SDL_BlitSurface(texto, 0, pantalla, &rectmsg);

    sprintf(ruta, "../imagenes/otros/flecha%d.png",flecha);
    SDL_Surface* flecha1 = IMG_Load(ruta);
     if(!flecha1)
    {
        cerr<<"Imposible cargar bitmap: "<< SDL_GetError()<<endl;
        exit(1);
    }
    rectflecha.y=475;
    SDL_BlitSurface(flecha1, 0, pantalla, &rectflecha);
}

Uint32 rapidez::observa(SDL_Surface* pantalla){
    bool done=false;
    Uint32 nivel=2, flecha, contflecha;
    carga: flecha=1+rand()%4;
    dibujaescenarioobs(pantalla);
    contflecha=dibujaflechas(nivel, flecha, pantalla);
    SDL_Flip(pantalla);
    SDL_Delay(1000);
    dibujaescenarioobs(pantalla);
    preguntarflechas(flecha, pantalla);
     while (!done)
    {
        // Manejo de eventos
        SDL_Event event;
        while(SDL_PollEvent(&event)){
        	//tecl.actualizar();
       		if(event.type==SDL_QUIT){
        		done=true;
        		break;
       		 }
                if(event.type==SDL_MOUSEBUTTONDOWN)
                {
                    Uint32 mousex, mousey;
                    mousex=event.button.x;
                    mousey=event.button.y;
                    //Comprobacion btn modo arcade
                    if(mousex>630&&mousey>20&&mousex<(630+150)&&mousey<(20+40)){
                        cout<<"Pulsacion de boton: Salir"<<endl;
                        done=true;
                    }
                }
                if(event.type==SDL_KEYDOWN)
                {
                    switch(event.key.keysym.sym){
                        case SDLK_1:
                            if(contflecha==1){
                                if(nivel!=8){
                                    nivel++;
                                    goto carga;
                                }
                                else{
                                    done=true;
                                    cout<<"Fin del juego"<<endl;
                                }
                            }
                            else{
                                done=true;
                                cout<<"Error numero incorrecto"<<endl;
                            }
                            break;
                        case SDLK_KP1:{
                            if(contflecha==1){
                                if(nivel!=8){
                                    nivel++;
                                    goto carga;
                                }
                                else{
                                    done=true;
                                    cout<<"Fin del juego"<<endl;
                                }
                            }
                            else{
                                done=true;
                                cout<<"Error numero incorrecto"<<endl;
                            }
                        }
                        break;
                        case SDLK_2:
                            if(contflecha==2){
                                if(nivel!=8){
                                    nivel++;
                                    goto carga;
                                }
                                else{
                                    done=true;
                                    cout<<"Fin del juego"<<endl;
                                }
                            }
                            else{
                                done=true;
                                cout<<"Error numero incorrecto"<<endl;
                            }
                            break;
                        case SDLK_KP2:{
                            if(contflecha==2){
                                if(nivel!=8){
                                    nivel++;
                                    goto carga;
                                }
                                else{
                                    done=true;
                                    cout<<"Fin del juego"<<endl;
                                }
                            }
                            else{
                                done=true;
                                cout<<"Error numero incorrecto"<<endl;
                            }
                        }
                        break;
                        case SDLK_3:
                            if(contflecha==3){
                                if(nivel!=8){
                                    nivel++;
                                    goto carga;
                                }
                                else{
                                    done=true;
                                    cout<<"Fin del juego"<<endl;
                                }
                            }
                            else{
                                done=true;
                                cout<<"Error numero incorrecto"<<endl;
                            }
                            break;
                        case SDLK_KP3:{
                            if(contflecha==3){
                                if(nivel!=8){
                                    nivel++;
                                    goto carga;
                                }
                                else{
                                    done=true;
                                    cout<<"Fin del juego"<<endl;
                                }
                            }
                            else{
                                done=true;
                                cout<<"Error numero incorrecto"<<endl;
                            }
                        }
                        break;
                         case SDLK_4:
                            if(contflecha==4){
                                if(nivel!=8){
                                    nivel++;
                                    goto carga;
                                }
                                else{
                                    done=true;
                                    cout<<"Fin del juego"<<endl;
                                }
                            }
                            else{
                                done=true;
                                cout<<"Error numero incorrecto"<<endl;
                            }
                            break;
                        case SDLK_KP4:{
                            if(contflecha==4){
                                if(nivel!=8){
                                    nivel++;
                                    goto carga;
                                }
                                else{
                                    done=true;
                                    cout<<"Fin del juego"<<endl;
                                }
                            }
                            else{
                                done=true;
                                cout<<"Error numero incorrecto"<<endl;
                            }
                        }
                        break;
                         case SDLK_5:
                            if(contflecha==5){
                                if(nivel!=8){
                                    nivel++;
                                    goto carga;
                                }
                                else{
                                    done=true;
                                    cout<<"Fin del juego"<<endl;
                                }
                            }
                            else{
                                done=true;
                                cout<<"Error numero incorrecto"<<endl;
                            }
                            break;
                        case SDLK_KP5:{
                            if(contflecha==5){
                                if(nivel!=8){
                                    nivel++;
                                    goto carga;
                                }
                                else{
                                    done=true;
                                    cout<<"Fin del juego"<<endl;
                                }
                            }
                            else{
                                done=true;
                                cout<<"Error numero incorrecto"<<endl;
                            }
                        }
                        break;
                         case SDLK_6:
                            if(contflecha==6){
                                if(nivel!=8){
                                    nivel++;
                                    goto carga;
                                }
                                else{
                                    done=true;
                                    cout<<"Fin del juego"<<endl;
                                }
                            }
                            else{
                                done=true;
                                cout<<"Error numero incorrecto"<<endl;
                            }
                            break;
                        case SDLK_KP6:{
                            if(contflecha==6){
                                if(nivel!=8){
                                    nivel++;
                                    goto carga;
                                }
                                else{
                                    done=true;
                                    cout<<"Fin del juego"<<endl;
                                }
                            }
                            else{
                                done=true;
                                cout<<"Error numero incorrecto"<<endl;
                            }
                        }
                        break;
                         case SDLK_7:
                            if(contflecha==7){
                                if(nivel!=8){
                                    nivel++;
                                    goto carga;
                                }
                                else{
                                    done=true;
                                    cout<<"Fin del juego"<<endl;
                                }
                            }
                            else{
                                done=true;
                                cout<<"Error numero incorrecto"<<endl;
                            }
                            break;
                        case SDLK_KP7:{
                            if(contflecha==7){
                                if(nivel!=8){
                                    nivel++;
                                    goto carga;
                                }
                                else{
                                    done=true;
                                    cout<<"Fin del juego"<<endl;
                                }
                            }
                            else{
                                done=true;
                                cout<<"Error numero incorrecto"<<endl;
                            }
                        }
                        break;
                         case SDLK_8:
                            if(contflecha==8){
                                if(nivel!=8){
                                    nivel++;
                                    goto carga;
                                }
                                else{
                                    done=true;
                                    cout<<"Fin del juego"<<endl;
                                }
                            }
                            else{
                                done=true;
                                cout<<"Error numero incorrecto"<<endl;
                            }
                            break;
                        case SDLK_KP8:{
                            if(contflecha==8){
                                if(nivel!=8){
                                    nivel++;
                                    goto carga;
                                }
                                else{
                                    done=true;
                                    cout<<"Fin del juego"<<endl;
                                }
                            }
                            else{
                                done=true;
                                cout<<"Error numero incorrecto"<<endl;
                            }
                        }
                        break;
                        case SDLK_9:
                            if(contflecha==9){
                                if(nivel!=8){
                                    nivel++;
                                    goto carga;
                                }
                                else{
                                    done=true;
                                    cout<<"Fin del juego"<<endl;
                                }
                            }
                            else{
                                done=true;
                                cout<<"Error numero incorrecto"<<endl;
                            }
                            break;
                        case SDLK_KP9:{
                            if(contflecha==9){
                                if(nivel!=8){
                                    nivel++;
                                    goto carga;
                                }
                                else{
                                    done=true;
                                    cout<<"Fin del juego"<<endl;
                                }
                            }
                            else{
                                done=true;
                                cout<<"Error numero incorrecto"<<endl;
                            }
                        }
                        break;
                        case SDLK_0:
                            if(contflecha==0){
                                if(nivel!=8){
                                    nivel++;
                                    goto carga;
                                }
                                else{
                                    done=true;
                                    cout<<"Fin del juego"<<endl;
                                }
                            }
                            else{
                                done=true;
                                cout<<"Error numero incorrecto"<<endl;
                            }
                            break;
                        case SDLK_KP0:{
                            if(contflecha==0){
                                if(nivel!=8){
                                    nivel++;
                                    goto carga;
                                }
                                else{
                                    done=true;
                                    cout<<"Fin del juego"<<endl;
                                }
                            }
                            else{
                                done=true;
                                cout<<"Error numero incorrecto"<<endl;
                            }
                        }
                        break;
                        default:
                            cout<<"Tecla incorrecta"<<endl;
                    }
                }
        }
        SDL_Flip(pantalla);
     }
    
    return nivel-1;
}

void rapidez::dibujaescenarioojo(SDL_Surface* pantalla){
    SDL_FillRect(pantalla,NULL,SDL_MapRGB(pantalla->format,96,96,106));
}

void rapidez::dibujacerradura(SDL_Surface* pantalla){
    SDL_Surface* cerrad = IMG_Load("../imagenes/fondos/ojodecerradura_trans.png");
     if(!cerrad)
    {
        cerr<<"Imposible cargar imagen: "<< SDL_GetError()<<endl;
        exit(1);
    }
    SDL_BlitSurface(cerrad, 0, pantalla, 0);
        SDL_Surface* boton1 = IMG_Load("../imagenes/botones/Salir.png");
     if(!boton1)
    {
        cerr<<"Imposible cargar imagen: "<< SDL_GetError()<<endl;
        exit(1);
    }
    SDL_Rect rectbtn;
    rectbtn.x=630;
    rectbtn.y=20;
    SDL_BlitSurface(boton1, 0, pantalla, &rectbtn);
}

void rapidez::dibujanumeroojo(SDL_Surface* supernum, Uint32 posx, SDL_Surface* pantalla){
    SDL_Rect dest;
    dest.x=posx;
    dest.y=386;
    SDL_BlitSurface(supernum, 0, pantalla, &dest);
    dibujacerradura(pantalla);
}

void rapidez::movimientonumojo(SDL_Surface* supernum, Uint32 *posx, Uint32 nivel, SDL_Surface* pantalla){
    dibujaescenarioojo(pantalla);
    (*posx)-=((nivel/2)+1+nivel%2)*2;   //Solo aumentara la velocidad en niveles impares
    dibujanumeroojo(supernum, *posx, pantalla);
    
}
SDL_Surface* rapidez::crearsuperficienumojo(Uint32 numero, int *w){
    char cadena[100]; //Cadena con el numero generado automaticamente
    int h;
    //Cargamos los tipos de letras
    TTF_Font *fuente;
    fuente = TTF_OpenFont("../fuentes/FreeSansBold.ttf", 40);
    if(!fuente)
    {
        cerr<<"Error no se encuentra la fuente: "<<SDL_GetError()<<endl;
        exit(1);
    }
    //Cargamos el numero a recordar
    SDL_Surface *texto;
    SDL_Color color;
    // Establecemos el color para la fuente
    color.r = 255;
    color.g = 255;
    color.b = 255;
    sprintf(cadena,"%d",numero);
    TTF_SizeUTF8(fuente, cadena, w, &h);
    texto = TTF_RenderText_Blended(fuente, cadena, color);
    return texto;
}

Uint32 rapidez::generanumeroojo(Uint32 nivel, Uint32 *numcifras){
    Uint32 numero, min, max=10;
    *numcifras=(nivel/2)+1;
   //Si es par aumentamos el numero de cifras
    max=potencia(10,*numcifras);
    //max=pow((double)10,*numcifras);
    min=max/10;
    //Con esto conseguimos acotar el numero que genera eliminando los numeros que empiezan por 0 y por tanto con menos cifras
    numero=min+rand()%(max-min+1);
    return numero;

}

void rapidez::dibujanumeroojo(Uint32 numero, SDL_Surface* pantalla){
    if(numero!=0){
        char cadena[100]; //Cadena con el numero generado automaticamente
        int w, h;
        //Cargamos los tipos de letras
        TTF_Font *fuente;
        fuente = TTF_OpenFont("../fuentes/FreeSansBold.ttf", 30);
        if(!fuente)
        {
            cerr<<"Error no se encuentra la fuente: "<<SDL_GetError()<<endl;
            exit(1);
        }
        //Cargamos el numero a recordar
        SDL_Surface *texto;
        SDL_Color color;
        // Establecemos el color para la fuente
        color.r = 255;
        color.g = 255;
        color.b = 255;
        sprintf(cadena,"%d",numero);
        TTF_SizeUTF8(fuente, cadena, &w, &h);
        texto = TTF_RenderText_Blended(fuente, cadena, color);
        SDL_Rect dest;

        //Centramos horizontalmente el texto
        dest.x = 400-(w/2);
        dest.y = 175;
        SDL_BlitSurface(texto, 0, pantalla, &dest);
    }
}

Uint32 rapidez::ojodecerradura(SDL_Surface* pantalla){
    bool done=false;
    char cifras[30];
    Uint32 numero, nivel=2, posx=454, indicecif=0, numobtenido;
    Uint32 numcifras;
    //Aqui almacenamos la anchura del numero a mostrar
    int w;
    //Almacenaremos la superficie del numero para no cargar demasiado el rendimiento del pc
    SDL_Surface *supernum;

    //Rellenamos con aes
    for(Uint32 i=0;i<30;i++){
        cifras[i]='a';
    }
    //Cargamos el mensaje para que el usuario introduzca el numero
    //Cargamos los tipos de letras
    TTF_Font *fuente, *fuente2;
    fuente = TTF_OpenFont("../fuentes/FreeSans.ttf", 20);
    fuente2 = TTF_OpenFont("../fuentes/FreeSansBold.ttf", 30);
    //Cargamos el numero a recordar
    SDL_Surface *texto;
    SDL_Surface *correcto;
    SDL_Color color;
    // Establecemos el color para la fuente
    color.r = 255;
    color.g = 255;
    color.b = 255;
    texto = TTF_RenderText_Blended(fuente, "Introduce el numero ahora", color);
    correcto = TTF_RenderText_Blended(fuente2, "Correcto", color);

    //Cargamos el escenario, generamos el numero y dibujamos el numero
    dibujaescenarioojo(pantalla);
    numero=generanumeroojo(nivel, &numcifras);
    supernum=crearsuperficienumojo(numero, &w);
    dibujanumeroojo(supernum, posx, pantalla);
    //Esperamos que el usuario vea el mensaje
    SDL_Flip(pantalla);
    SDL_Delay(1000);
    //Bucle de ojo de cerradura
    while (!done)
    {
        // Manejo de eventos
        SDL_Event event;
        while(SDL_PollEvent(&event)){
        	//tecl.actualizar();
       		if(event.type==SDL_QUIT){
        		done=true;
        		break;
       		 }
                if(event.type==SDL_MOUSEBUTTONDOWN)
                {
                    Uint32 mousex, mousey;
                    mousex=event.button.x;
                    mousey=event.button.y;
                    if(mousex>630&&mousey>20&&mousex<(630+150)&&mousey<(20+40)){
                        cout<<"Pulsacion de boton: Salir"<<endl;
                        done=true;
                    }
                }
                if((event.type==SDL_KEYDOWN)&&(posx<(350-w)))
                {
                    switch(event.key.keysym.sym){
                        case SDLK_BACKSPACE:{
                            if(indicecif!=0){
                                indicecif--;
                                cifras[indicecif]='a';
                                numobtenido/=10;
                                cout<<"Numobtenido: "<<numobtenido<<endl;
                            }
                        }
                        break;
                        case SDLK_1:{
                            cifras[indicecif]='1';
                            sscanf(cifras,"%d",&numobtenido);
                            indicecif++;
                        }
                        break;
                        case SDLK_KP1:{
                            cifras[indicecif]='1';
                            sscanf(cifras,"%d",&numobtenido);
                            indicecif++;
                        }
                        break;
                        case SDLK_2:{
                            cifras[indicecif]='2';
                            sscanf(cifras,"%d",&numobtenido);
                            indicecif++;
                        }
                        break;
                        case SDLK_KP2:{
                            cifras[indicecif]='2';
                            sscanf(cifras,"%d",&numobtenido);
                            indicecif++;
                        }
                        break;
                        case SDLK_3:{
                            cifras[indicecif]='3';
                            sscanf(cifras,"%d",&numobtenido);
                            indicecif++;
                        }
                        break;
                        case SDLK_KP3:{
                            cifras[indicecif]='3';
                            sscanf(cifras,"%d",&numobtenido);
                            indicecif++;
                        }
                        break;
                        case SDLK_4:{
                            cifras[indicecif]='4';
                            sscanf(cifras,"%d",&numobtenido);
                            indicecif++;
                        }
                        break;
                        case SDLK_KP4:{
                            cifras[indicecif]='4';
                            sscanf(cifras,"%d",&numobtenido);
                            indicecif++;
                        }
                        break;
                        case SDLK_5:{
                            cifras[indicecif]='5';
                            sscanf(cifras,"%d",&numobtenido);
                            indicecif++;
                        }
                        break;
                        case SDLK_KP5:{
                            cifras[indicecif]='5';
                            sscanf(cifras,"%d",&numobtenido);
                            indicecif++;
                        }
                        break;
                        case SDLK_6:{
                            cifras[indicecif]='6';
                            sscanf(cifras,"%d",&numobtenido);
                            indicecif++;
                        }
                        break;
                        case SDLK_KP6:{
                            cifras[indicecif]='6';
                            sscanf(cifras,"%d",&numobtenido);
                            indicecif++;
                        }
                        break;
                        case SDLK_7:{
                            cifras[indicecif]='7';
                            sscanf(cifras,"%d",&numobtenido);
                            indicecif++;
                        }
                        break;
                        case SDLK_KP7:{
                            cifras[indicecif]='7';
                            sscanf(cifras,"%d",&numobtenido);
                            indicecif++;
                        }
                        break;
                        case SDLK_8:{
                            cifras[indicecif]='8';
                            sscanf(cifras,"%d",&numobtenido);
                            indicecif++;
                        }
                        break;
                        case SDLK_KP8:{
                            cifras[indicecif]='8';
                            sscanf(cifras,"%d",&numobtenido);
                            indicecif++;
                        }
                        break;
                        case SDLK_9:{
                            cifras[indicecif]='9';
                            sscanf(cifras,"%d",&numobtenido);
                            indicecif++;
                        }
                        break;
                        case SDLK_KP9:{
                            cifras[indicecif]='9';
                            sscanf(cifras,"%d",&numobtenido);
                            indicecif++;
                        }
                        break;
                        case SDLK_0:{
                            cifras[indicecif]='0';
                            sscanf(cifras,"%d",&numobtenido);
                            indicecif++;
                        }
                        break;
                        case SDLK_KP0:{
                            cifras[indicecif]='0';
                            sscanf(cifras,"%d",&numobtenido);
                            indicecif++;
                        }
                        break;
                        default:cout<<"Tecla incorrecta"<<endl;
                            break;
                    }
                    if(numobtenido==numero){
                        cout<<"Correcto"<<endl;
                        dibujaescenarioojo(pantalla);
                        //Dibuja el mensaje
                        SDL_Rect rectext;
                        rectext.x=300;
                        rectext.y=550;
                        SDL_BlitSurface(texto, 0, pantalla, &rectext);
                        dibujacerradura(pantalla);
                        dibujanumeroojo(numobtenido, pantalla);
                        //Mostramos un mensaje de correcto
                        rectext.x=600;
                        rectext.y=250;
                        SDL_BlitSurface(correcto, 0, pantalla, &rectext);
                        SDL_Flip(pantalla);
                        SDL_Delay(1000);
                        nivel++;
                        //Cargamos el escenario, generamos el numero y dibujamos el numero
                        dibujaescenarioojo(pantalla);
                        numero=generanumeroojo(nivel, &numcifras);
                        supernum=crearsuperficienumojo(numero, &w);
                        posx=454;
                        dibujanumeroojo(supernum, posx, pantalla);
                        for(int i=0;i<30;i++)
                            cifras[i]='a';
                        indicecif=0;
                        
                    }
                    else if((numobtenido/potencia(10,numcifras-1))>=1){
                        //Incorrecto
                        cout<<"Incorrecto"<<endl;
                        done=true;
                    }
                    else{
                        dibujaescenarioojo(pantalla);
                        //Dibuja el mensaje
                        SDL_Rect rectext;
                        rectext.x=300;
                        rectext.y=550;
                        SDL_BlitSurface(texto, 0, pantalla, &rectext);
                        dibujacerradura(pantalla);
                        dibujanumeroojo(numobtenido, pantalla);
                    }
                    
                }
        }
        if(!(posx<(350-w)))
            movimientonumojo(supernum, &posx, nivel, pantalla);
        else{
            //Dibuja el mensaje
            SDL_Rect rectext;
            rectext.x=300;
            rectext.y=550;
            SDL_BlitSurface(texto, 0, pantalla, &rectext);
        }
        SDL_Flip(pantalla);
    }
    return nivel-1;
}

rapidez::~rapidez() {
}

