/*###############################################################################
## OpenBTrainer project
##
## Copyright (C) 2009 Jose Luis Falcón Ramírez  jose.falconra@alum.uca.es
##
## This program is free software; you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published by
## the Free Software Foundation; either version 3 of the License, or
## (at your option) any later version.
##
## This program is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.
##
## You should have received a copy of the GNU General Public License
## along with this program; if not, write to the Free Software
## Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
###############################################################################*/


#ifndef _rapidez_H
#define	_rapidez_H
/** Clase rapidez: En ella se llama a los juegos que entran en las distintas categorías disponibles
 */
class rapidez {
public:
    /**Constructor de la clase rapidez*/
    rapidez();
    rapidez(const rapidez& orig);
    /**inicia el juego de recordar dígitos
    * @param pantalla: recibe la superficie de la pantalla inicializada
    */
    Uint32 recuerda(SDL_Surface *pantalla);
    /** Inicia el juego de Observación
     * @param pantalla: recibe la superficie de la pantalla inicializada
     */
    Uint32 observa(SDL_Surface *pantalla);
    /** Inicia el juego Ojo de Cerradura
     * @param pantalla: recibe la superficie de la pantalla inicializada
     */
    Uint32 ojodecerradura(SDL_Surface *pantalla);
    
    virtual ~rapidez();
private:
    /** Dibuja el escenario de nuevo*/
    void dibujaescenariorec(SDL_Surface* pantalla);
    /** Nos sirve para dibujar en pantalla el número que le pasamos como parámetro
     * @param numero: Número que será escrito en pantalla
     * @param principal: Nos sirve para especificar el lugar donde se escribirá el número, si está a true se escribirá en la zona
     * principal, es decir, será el número que deseamos que el jugador recuerde, en caso contrario se escribirá en la zona destinada
     * a que el usuario introduzca los números
     * @param pantalla: recibe la superficie de la pantalla inicializada
     */
    void dibujanumerorec(Uint32 numero, bool principal, SDL_Surface* pantalla);
    /** Genera un número aleatorio con las cifras que le indica el número de nivel que se le pasa como parámetro
     * @param nivel: recibe el nivel en el que nos encontramos, ya que según el nivel en el que nos encontremos habrá que incrementar
     * una cifra en el número generado
     */
    Uint32 generanumerorec(Uint32 nivel);

    void dibujaescenarioobs(SDL_Surface* pantalla);
    Uint32 dibujaflechas(Uint32 nivel, Uint32 flecha, SDL_Surface* pantalla);
    void preguntarflechas(Uint32 flecha, SDL_Surface* pantalla);

    void dibujaescenarioojo(SDL_Surface* pantalla);
    void dibujacerradura(SDL_Surface* pantalla);
    void dibujanumeroojo(SDL_Surface* supernum, Uint32 posx, SDL_Surface* pantalla);
    void movimientonumojo(SDL_Surface* supernum, Uint32 *posx, Uint32 nivel, SDL_Surface* pantalla);
    SDL_Surface* crearsuperficienumojo(Uint32 numero, int *w);
    Uint32 generanumeroojo(Uint32 nivel, Uint32 *numcifras);
    void dibujanumeroojo(Uint32 numero, SDL_Surface* pantalla);



};

#endif	 /*_rapidez_H*/

